
draw_thread:	    ; in: ebx - thread number; 0 - first thread
    push   ebp
    mov    ebp,esp
    sub    esp,300
    and    ebp,-16
    sub    ebp,128  ; to make shorter locals adresses


   .thread_no	    equ dword[ebp-4]
   .x_min	    equ word[ebp-6]
   .x_max	    equ word[ebp-8]
   .y_min	    equ [ebp-10]
   .y_max	    equ [ebp-12]
   .y_max_draw_thrd equ [ebp-12]	  ; some shame 'cicer cum caule'
   .third_p_index   equ dword[ebp-16]	  ; local data definitions - sorry
   .second_p_index  equ dword[ebp-20]
   .first_p_index   equ dword[ebp-24]
   .xy3 	    equ ebp-40
   .xy2 	    equ ebp-44
   .xy1 	    equ ebp-48
   .zz3 	    equ       [ebp-52]
   .zz2 	    equ       [ebp-54]
   .zz1 	    equ       [ebp-56]

   .scr 	    equ dword [ebp-64] ;  \
   .zbuf	    equ dword [ebp-68] ;  | > dont change order - line fctions!!
   .line_tex_ptr    equ  dword[ebp-72] ;  |	      ; cover .in1
   .width	    equ       [ebp-76] ;  /	      ; cover .in2
   .line_horiz	    equ       [ebp-80]		      ; cover .in3

   .in1 	    equ       [ebp-72]
   .in2 	    equ       [ebp-76]
   .in3 	    equ       [ebp-80]

   .por 	    equ dword [ebp-84]
   .pnr 	    equ dword [ebp-88]
   .tex_pts	    equ dword [ebp-92]
   .cur_tri	    equ dword [ebp-96]
   .zer_hgst	    equ       [ebp-112]
   .pack1	    equ       [ebp-128]   ; min max compare
   .tri_proc	    equ dword [ebp]
   .col 	    equ dword [ebp]	  ; covers tri proc
   .en_draw	    equ dword [ebp+4]
   .mask255f	    equ       [ebp+16]
   .draw_flag		equ dword [ebp+40]
   .tx_line		equ dword [ebp+44]
   .correct_texf	equ	  [ebp+48]
   .tx_esi		equ dword [ebp+64]
   .tex_points_f_ptr	equ dword [ebp+68]
   .env_hint		equ dword [ebp+76]
   .xres		equ	  [ebp+80]
   .yres		equ word  [ebp+82]
   .line_call		equ	  [ebp+86]
   .pack2		equ	  [ebp+96]
   .f4x4		equ	  [ebp+112]




    mov     .thread_no,ebx
    mov     .en_draw,.end_draw
    movaps  xmm0,[correct_texf]
    movaps  .correct_texf,xmm0
    push    [points_rotated_ptr]
    pop     .por
    push    [points_normals_rotated_ptr]
    pop     .pnr

    pcmpeqd  xmm0,xmm0
    psrldq   xmm0,4
    movaps   .zer_hgst,xmm0
    psrld    xmm0,24
    cvtdq2ps xmm0,xmm0
    movaps   .mask255f,xmm0

    push    [tex_points_ptr]
    pop     .tex_pts
    push    [screen_ptr]
    pop     .scr
    push    [Zbuffer_ptr]
    pop     .zbuf
    push    [tex_points_f_ptr]
    pop     .tex_points_f_ptr

    push    dword [xres_vard]
    pop     dword .xres

    movzx   edx,[draw_flag]
    mov     .draw_flag,edx


	xor	   eax,eax
	mov	   edi,1
	cmp	   dl,3
	cmove	   eax,edi
   ;	 mov	    .env_hint,eax    ; env mapping
	cmove	   ebx,[tlz]  ;textured_line_z

	cmp	   dl,4
	cmove	   ebx,[blz]  ;bump_line_z

	cmp	   dl,5
	cmove	   ebx,[tlz]  ;textured_line_z

	cmp	   dl,7
	cmove	   ebx,[t2lz] ;two_tex_line

	cmp	   dl,8
	cmove	   ebx,[blt]  ;bump_tex_line_z
	mov	   .tx_line,ebx
	mov	   .tx_esi,esi
	mov	   .env_hint,eax

    cld
    mov    eax,.thread_no

    cmp    dl,9
    jl	   @f
    cmp    dl,10  ; flat draw float cause
    je	   @f
    cmp    .draw_flag,14
    je	   .draw_vertices
    push   .yres
    pop    word .y_max
    mov    .y_min,word 0
    push   word .xres
    pop    .x_max
    mov    .x_min,word 0

      pxor	 xmm3,xmm3
      movdqu	 xmm1,.y_max_draw_thrd
      punpcklwd  xmm1,xmm3
  ;    xorps	  xmm2,xmm2
      pshufd	 xmm1,xmm1,10110001b  ; xm1 lo - hi =  ymin ymax xmin xmax
      call	 do_shadow
      jmp	 .draw_edges
  @@:

    movzx  ebx,.yres
    shr    ebx,1   ; shr ebx,n ;n=1 - 2 threads, n=2 - 4 threads...
    mov    ecx,ebx
    imul   ebx,eax
    mov    .y_min,bx
    add    ebx,ecx
    mov    .y_max,bx
    mov    .x_min,word 0
    push   word .xres
    pop    .x_max

  .skip_div:

       pcmpeqd	xmm3,xmm3
       psrld	xmm3,16
       movq	xmm1,.y_max
       movq	xmm2,.y_min
       pand	xmm1,xmm3 ;[draw_thread_mask]
       pand	xmm2,xmm3 ;[draw_thread_mask]
       packssdw xmm1,xmm1
       packssdw xmm2,xmm2

       pshufd	xmm1,xmm1,0
       pshufd	xmm2,xmm2,0
       movdqa	.pack1,xmm1
       movdqa	.pack2,xmm2

      cmp	 [shadow_flag],1
      jne	 @f
      pxor	 xmm3,xmm3
      movdqu	 xmm1,.y_max_draw_thrd
      punpcklwd  xmm1,xmm3
   ;   xorps	  xmm2,xmm2
      pshufd	 xmm1,xmm1,10110001b  ; xm1 lo - hi =  ymin ymax xmin xmax
      call	 do_shadow
    @@:

    mov      esi,[triangles_ptr]	    ; draw triangles
    xor      ecx,ecx
  .draw_triangle:
    push     ecx
    push     esi
    pushad
    mov      .cur_tri,ecx

    cmp      [culling_flag],1
    je	     @f
    imul     ecx,12
    add      ecx,[triangles_normals_rotated_ptr]
    bt	     dword[ecx+8],31
    jnc      .end_draw
  @@:
    mov     edx,dword[esi]
    mov     eax,dword[esi+4]
    mov     ebx,dword[esi+8]
    shl     edx,2
    shl     eax,2
    shl     ebx,2
    mov     .in1,edx
    mov     .in2,eax
    mov     .in3,ebx
    lea     edx,[edx*3]
    lea     eax,[eax*3]
    lea     ebx,[ebx*3]
    mov     .first_p_index,edx
    mov     .second_p_index,eax
    mov     .third_p_index,ebx
    mov     ecx,.por
    movups  xmm0,[edx+ecx]
    movups  xmm1,[eax+ecx]
    movups  xmm2,[ebx+ecx]
    shufps  xmm0,xmm0,11100001b
    shufps  xmm1,xmm1,11100001b
    shufps  xmm2,xmm2,11100001b

    movaps    xmm4,xmm0
    movhlps   xmm4,xmm1
    shufps    xmm4,xmm4,10000010b
    movhlps   xmm5,xmm2
    movlhps   xmm4,xmm5
    andps     xmm4,.zer_hgst

    cvtps2dq  xmm0,xmm0
    cvtps2dq  xmm1,xmm1
    cvtps2dq  xmm2,xmm2
    packssdw  xmm0,xmm0
    packssdw  xmm1,xmm1
    packssdw  xmm2,xmm2
    movd      [.xy1],xmm0
    movd      [.xy2],xmm1
    movd      [.xy3],xmm2


	movdqu	 xmm0,[.xy1]   ; check if at last only fragment
	movdqa	 xmm3,xmm0     ; is visable

	pcmpgtw  xmm0,.pack1   ;max
	pcmpgtw  xmm3,.pack2   ;min
	pmovmskb ecx,xmm0
	pmovmskb eax,xmm3
	and	 ecx,0xfff
	and	 eax,0xfff
	cmp	 ecx,0xfff
	jz	 .end_draw
	or	 eax,eax
	jz	 .end_draw

    mov       eax,.draw_flag
    add       eax,eax
    add       eax,render_optss
    movzx     edi,byte[eax]
    bt	      edi,6   ; z float
    jc	      @f
    cvtps2dq  xmm4,xmm4
    packssdw  xmm4,xmm4
    movq      .zz1,xmm4

 @@:
    bt	       edi,0
    jnc        @f

	mov	   ecx,.pnr	   ; col
	mov	   eax,.first_p_index
	mov	   ebx,.second_p_index
	mov	   edx,.third_p_index
	movaps	   xmm5,.correct_texf
	movlps	   xmm7,[eax+ecx]
	movhps	   xmm7,[ebx+ecx]
	movlps	   xmm2,[edx+ecx]
	mulps	   xmm7,xmm5
	mulps	   xmm2,xmm5
	addps	   xmm7,xmm5
	addps	   xmm2,xmm5

	cvtps2dq   xmm7,xmm7
	cvtps2dq   xmm2,xmm2
	pslld	   xmm7,2
	pslld	   xmm2,2

	sub	   esp,8
	movq	   [esp],xmm2
	pop	   eax ebx

	mov	   edx,color_map
	shl	   ebx,TEX_SHIFT
	add	   eax,ebx
	movd	   xmm2,[eax+edx]

	sub	   esp,16
	movdqu	   [esp],xmm7
	pop	   eax ebx
	shl	   ebx,TEX_SHIFT
	add	   eax,ebx
	movd	   xmm0,[eax+edx]

	pop	   eax ebx
	shl	   ebx,TEX_SHIFT
	add	   eax,ebx
	movd	   xmm1,[eax+edx]

	pxor	   xmm3,xmm3
	punpcklbw  xmm0,xmm3  ; colors - words in xmm0
	punpcklbw  xmm1,xmm3  ; colors - words in xmm0
	punpcklbw  xmm2,xmm3  ; and xmm2
	movlhps    xmm0,xmm1

	bt	   edi,3
	jc	   @f
	  mov	   eax,0x55555555  ; flat cause
	  movhlps  xmm3,xmm0
	  paddw    xmm2,xmm0
	  paddw    xmm2,xmm3
	  movd	   xmm3,eax
	  pshufd   xmm3,xmm3,0
	  pmulhuw  xmm3,xmm2
	  packuswb xmm3,xmm3	    ; flat in xmm3

    @@:
       bt	  edi,5
       jnc	  @f
	pxor	   xmm7,xmm7
	movq	   xmm5,.y_max
	punpcklwd  xmm5,xmm7
	pshufd	   xmm5,xmm5,10110001b

     @@:

	bt	  edi,1   ; env map
	jnc	  .texx

	movaps	  xmm7,.correct_texf
	mov	  ecx,.pnr
	mov	  eax,.first_p_index
	mov	  ebx,.second_p_index
	mov	  edx,.third_p_index
	movlps	  xmm2,[eax+ecx]
	movhps	  xmm2,[ebx+ecx]
	movlps	  xmm1,[edx+ecx]
	mulps	  xmm2,xmm7
	addps	  xmm2,xmm7
	mulps	  xmm1,xmm7
	addps	  xmm1,xmm7
	cvttps2dq xmm2,xmm2
	cvttps2dq xmm1,xmm1
    ;	 bt	   edi,9   ; bump
    ;	 jc	   .texx;
	packssdw  xmm2,xmm2
	packssdw  xmm1,xmm1
	movlhps   xmm1,xmm2
	pshufd	  xmm1,xmm1,00001110b

     .texx:

	bt	edi,2  ; tex
	jnc    .grc    ;.norm
	mov    edx,.tex_pts
	mov    eax,.in3
	mov    ebx,.in2
	mov    ecx,.in1
	push   dword[eax+edx]
	push   dword[ebx+edx]
	push   dword[ecx+edx]
	movdqu xmm6,[esp]
	add    esp,12
     .grc:
	bt	  edi,3    ; grd col - mixed with z
	jnc	  @f	   ; xmm0 - xmm2
	movzx	  eax,word .zz1
	movzx	  ebx,word .zz2
	movzx	  ecx,word .zz3
	pinsrw	  xmm0,eax,3
	pinsrw	  xmm0,ebx,7
	pinsrw	  xmm2,ecx,3
     @@:

   .no_opts:
    mov   eax,.draw_flag
    cmp   al,1
    je	  .flat_draw_float
    cmp   al,2
    je	  .grd_draw
    cmp   al,6
    je	  .grd_draw
    cmp   al,10
    je	  .flat_draw_float
    or	  al,al
    je	  .point_light
    jmp   .bump_tex_mapping



     .grd_draw: 	       ;****Gouraud shading****
	push	  word .y_max
	push	  word .y_min
	sub	  esp,24
	movups	  [esp],xmm0
	movq	  [esp+16],xmm2
	movaps	  xmm0,xmm6    ; tex coords
	mov	  eax,[.xy1]
	mov	  ebx,[.xy2]
	mov	  ecx,[.xy3]
	mov	  esi,[hgrd]   ; horizontal grd
	cmp	  .draw_flag,6
	cmove	  esi,[hgrdt]  ; horizontal grd tex
	movd	  xmm5,esi
	mov	  esi,.zbuf
	mov	  edi,.scr
	mov	  edx,texmap
	call	  tex_plus_grd_triangleA
	jmp	  .en_draw


    .flat_draw_float:

	  movd	   xmm5,.y_max
	  movzx    eax,word .xres
	  push	   eax
	  movaps   xmm0,xmm4	       ; z
	  movd	   edx,xmm3
	  or	   edx,0xff000000      ; edx - color
	  mov	   eax,[.xy1]
	  mov	   ebx,[.xy2]
	  mov	   ecx,[.xy3]
	  mov	   esi,.zbuf
	  mov	   edi,.scr
	  call	   flat_triangle_z_float
	  jmp	  .en_draw



    .bump_tex_mapping:
	mov	ebx,texmap
	cmp	.env_hint,0
	je	@f
	movaps	xmm6,xmm1
	mov	ebx,envmap
      @@:
	movd	xmm7,.tx_line
	push	word .y_max
	push	word .y_min
	sub	esp,16
	pslldq	xmm6,4
	movups	[esp],xmm6
	pop	eax
	push	ebx
	push	.zbuf
	push	word  .zz3
	push	word  .zz2
	push	word  .zz1
	sub	esp,16
	pslldq	xmm1,4
	movups	[esp],xmm1
	sub	esp,12
	movups	[esp],xmm6
	pop	eax
	mov	eax,[.xy1]
	mov	ebx,[.xy2]
	mov	ecx,[.xy3]
	mov	edi,.scr
	mov	esi,envmap
	mov	edx,bump_map		;BUMP_MAPPING
	call	bump_tex_triangle_z
	jmp	.en_draw

  .point_light:

    push     word .y_max
    push     word .y_min
    movups   xmm5,[ppoint_light_coords]
    xor      eax,eax
    lea      esi,.first_p_index
  .next_vertex:
    movaps   xmm1,xmm5
    mov      ebx,[esi+2*eax]

    mov      edx,ebx
    add      ebx,.por
    movups   xmm2,[ebx]
    andps    xmm2,.zer_hgst
    subps    xmm1,xmm2

    andps    xmm1,.zer_hgst
    movaps   xmm7,xmm1
    mulps    xmm7,xmm7
    haddps   xmm7,xmm7
    haddps   xmm7,xmm7
    rsqrtps  xmm7,xmm7
    mulps    xmm1,xmm7

    add      edx,.pnr
    movups   xmm3,[edx]
    mulps    xmm3,xmm1
    haddps   xmm3,xmm3	   ; sse3 required
    haddps   xmm3,xmm3	   ; xmm3 - dot product
    xorps    xmm4,xmm4
    maxps    xmm3,xmm4
    shufps   xmm3,xmm3,11000000b
    movaps   xmm4,xmm3
    mov      ecx,5
  @@:
    mulps    xmm4,xmm4
    loop     @b

;    imul     eax,[i38]     ; 38 - one light parameter size
    movq      xmm0,[p_light_max]    ;+eax
    pxor      xmm1,xmm1
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    mulps     xmm4,xmm2        ; xmm4 reflection(emmisive?) component of light

    movq      xmm0,[p_light_o] ;+ eax
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    addps     xmm4,xmm2

    movq      xmm0,[p_light_min] ; + eax
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0

    mulps     xmm2,xmm3
    addps     xmm4,xmm2
    minps     xmm4,.mask255f	 ; [mask_255f]

    cvtps2dq  xmm4,xmm4
    packssdw  xmm4,xmm4

    movd      edx,xmm4
    lea       edi,.zz1
    push      word[edi+eax]
    push      edx
    psrldq    xmm4,4
    movd      edx,xmm4
    push      dx

    add       eax,2
    cmp       eax,6
    jnz       .next_vertex

    mov      eax,[.xy3]
    mov      ebx,[.xy2]
    mov      ecx,[.xy1]
    mov      esi,.zbuf
    mov      edi,.scr
    movd     xmm5,[hgrd]  ; horizontal line adress
    call     tex_plus_grd_triangleA


  .end_draw:

    popad
    pop    esi
    add    esi,12
    pop    ecx
    inc    ecx
    cmp    ecx,[triangles_count_var]
    jnz    .draw_triangle
    jmp    .the_end

; edges      ******************************************************

 .draw_edges:

      mov      ecx,.draw_flag
      mov      esi,horizontal_grd
      mov      edi,horizontal_tx
      mov      edx,plain_horizontal
      cmp      cl,13
      cmove    edi,edx	 ; plain
      cmp      cl,9
      cmove    edi,esi	 ; grd
      mov      .line_call,dword line_grd_tex
      mov      .line_horiz,edi

      mov      edx,envmap
      mov      eax,texmap
      mov      ebx,color_map
      mov      esi,0x0000ff00
      cmp      cl,13
      cmove    edx,esi
      cmp      cl,12
      cmove    edx,eax
      cmp      cl,9	    ; .line_tex_ptr
      cmove    edx,ebx
      cmp      cl,11

      mov      .line_tex_ptr ,edx
      movzx    edx,word .xres
      mov      .width,edx

      mov      ecx,[edges_count]
      mov      esi,[edges_ptr]
     cld
  .dr_edge:
     push      ecx
     push      esi
     cmp       [culling_flag],1
     je        @f
     mov       ebx,[esi]
     imul      ebx,12
     add       ebx,.pnr
     bt        dword[ebx+8],31
     jnc       .end_dr_ed
  @@:
     mov      eax,[esi]
     mov      ebx,[esi+4]
     push     eax ebx
     imul     ebx,12
     imul     eax,12
     mov      edx,.por
     movlps   xmm4,[ebx+edx]
     movhps   xmm4,[eax+edx]
     cvtps2dq xmm4,xmm4

     movlps   xmm2,[ebx+edx+8]
     movlps   xmm3,[eax+edx+8]

     mov       edx,.pnr
     movlps    xmm0,[eax+edx]
     movhps    xmm0,[ebx+edx]
     movaps    xmm5,[correct_tex_x4f]
     mulps     xmm0,xmm5
     addps     xmm0,xmm5
   ;	xm0  - tex env/col coords as float
     cvtps2dq  xmm6,xmm0
     pop       ebx eax
   @@:		   ;
     cmp       .draw_flag,12
     jne       @f
     shl       eax,3
     shl       ebx,3
     add       eax,.tex_points_f_ptr ;.tex_pts
     add       ebx,.tex_points_f_ptr ;.tex_pts
     movups    xmm0,[eax]
     movups    xmm1,[ebx]
     jmp      .f22
    @@:
	cmp	 .draw_flag,13
	je	 .f22
	sub	 esp,16
	movdqu	 [esp],xmm6
	pop	 eax ebx ecx edx
	shl	 eax,TEX_SHIFT
	shl	 ecx,TEX_SHIFT
	add	 eax,ebx
	add	 ecx,edx
	mov	 ebx,.line_tex_ptr  ;color_map
	lea	 eax,[4*eax+ebx]
	lea	 ecx,[4*ecx+ebx]
	movd	 xmm0,[eax]
	movd	 xmm1,[ecx]
	pxor	   xmm6,xmm6
	punpcklbw  xmm0,xmm6
	punpcklbw  xmm1,xmm6
	punpcklwd  xmm0,xmm6
	punpcklwd  xmm1,xmm6
	cvtdq2ps   xmm0,xmm0
	cvtdq2ps   xmm1,xmm1
   .f22:
    sub       esp,16
    movdqu    [esp],xmm4
    pop       eax ebx ecx edx
    pxor      xmm6,xmm6
    movd      xmm7,dword .xres
    punpcklwd xmm7,xmm6
    movlhps   xmm7,xmm7
    movups    xmm5,.width
    mov       edi,.line_horiz
    call      dword .line_call
   .end_dr_ed:
    pop       esi
    pop       ecx
    add       esi,8
    dec       ecx
    jnz       .dr_edge
 ;   loop    .dr_edge

     jmp     .the_end

    .draw_vertices:
	mov	  esi,.por
	mov	  ecx,[points_count_var]
	movzx	  edx,word .xres
	or	  eax,-1
	pxor	  xmm3,xmm3
	movd	  xmm5,.xres
	punpcklwd xmm5,xmm3
	cld
      .again_vert:
	movups	  xmm0,[esi]
	cvtps2dq  xmm0,xmm0
	pxor	  xmm3,xmm3
	movaps	  xmm4,xmm5
	pcmpgtd   xmm4,xmm0
	pcmpgtd   xmm3,xmm0
	pxor	  xmm3,xmm4
	pmovmskb  ebx,xmm3
	cmp	  bl,0xff
	jne	  @f
	movd	  ebx,xmm0
	psrldq	  xmm0,4
	movd	  edi,xmm0
	imul	  edi,edx
	add	  edi,ebx
	shl	  edi,2
	add	  edi,.scr
	stosd
      @@:			  ;  skip vertex
	add	  esi,12
	loop	  .again_vert


  .the_end:

  add esp,300
  pop ebp
ret
