
;============================================================

triangulize_all_faces:     ;; teslate all tris from teslate area
; if eax = 'tiv' - teslate tris with at last one edge
; that intersect other tri and at last one inner vertex
;

; out:           esi - new triangles ptr
;                edi - new vertices ptr
;                ecx - new vertices count
;                ebx - new tris count




   .piv          equ  [ebp-4]
   .ptr          equ  [ebp-8]
   .index3       equ  [ebp-12]
   .index2       equ  [ebp-16]
   .index1       equ  [ebp-20]
   .mx           equ  [ebp-56]
   .new_vcnt     equ  dword[ebp-60]
   .new_vert_ptr equ  [ebp-64]
   .new_tri      equ  [ebp-68]
   .end_new_tri  equ  dword[ebp-72]
   .endt         equ  [ebp-76]
   .endin        equ  [ebp-80]
   .n_tri_cnt    equ  dword[ebp-84]
   .piv2         equ  dword[ebp-88]
   .tiv          equ  dword[ebp-92]

   push     ebp
   mov      ebp,esp
   sub      esp,100

   xor      ebx,ebx
   mov      edx,1
   cmp      eax,'tiv'
   cmove    ecx,edx
   cmovne   ecx,ebx
   mov      .tiv,ecx
   
   cmp      cl,1
   jne      @f
   cmp      [edges_intersect_ptr],ebx
   je       .end_aa
   cmp      [inner_vert_ptr],ebx
   je       .end_aa
  @@:  



   mov      ebx,[edges_count]
   shl      ebx,4
   add      ebx,60
   malloc   ebx
   mov      .piv,eax

   mov      eax,[points_count_var]
   shl      eax,2
   add      eax,60
   cmp      eax,ebx
   cmova    ebx,eax

   malloc   ebx
   mov      .piv2,eax
   mov      .ptr,eax

  ; make pivot table of edges
   mov       edi,.piv
   mov       esi,[edges_ptr]
   xor       ecx,ecx
   pxor      xmm0,xmm0
  @@:
   mov       eax,ecx
   movsd
   stosd
   movsd
   stosd

   inc       ecx
   cmp       ecx,[edges_count]
   jne       @b

 ;sort pivot table           - sort by qsort !!
   mov    esi,.piv
   mov    edi,.piv2

   mov    .endt,esi          ; calc end of  .piv
   mov    ecx,[edges_count]
   add    ecx,ecx
   mov    eax,ecx
   shl    eax,3
   add    .endt,eax

   call   sort_hybrid1   ; sort.inc


;make _ptr list
   mov    esi,.piv
   mov    edi,.ptr
  .bas:
   mov    ebx,esi    ; base
  .nob:              ; no base
   cmp    esi,.endt
   ja    .enn
   mov    eax,[esi]
   cmp    eax,[esi+8]
   je     @f
   shl    eax,2
   add    eax,.ptr
   mov    [eax],ebx   ; ptr of vertices, each position point to edges pivot tab
   add    esi,8
   jne    .bas
   jmp    .enn
  @@:
   add    esi,8
   cmp    esi,.endt
   jna    .nob

 .enn:

   mov     eax,[edges_count]
   add     eax,[points_count_var]
   mov     .new_vcnt,eax    ; all vertices count
   add     eax,10
   shl     eax,2
   lea     eax,[eax*3]

   malloc  eax


   mov    .new_vert_ptr,eax   ; new vertices and old vertices

    mov      ecx,[points_count_var]
    mov      esi,[points_r_ptr]
    mov      edi,eax
    mov      ebx,matrix_scaled
    call     rotary                     ; for extra accurate

    cvtdq2ps xmm3,[xxadd]
    andps    xmm3,[zero_hgst_dd]
    mov      ecx,[points_count_var]
    mov      ebx,.new_vert_ptr
  @@:
    movups   xmm1,[ebx]
    addps    xmm1,xmm3
    movups   [ebx],xmm1
    add      ebx,12
    loop     @b


    mov    edi,[points_count_var]
    lea    edi,[edi*3]
    shl    edi,2
    add    edi,.new_vert_ptr


   mov      esi,[edges_ptr]     ; calc all new vertices
   mov      ecx,[edges_count]
   mov      eax,0.5
   movd     xmm0,eax
   shufps   xmm0,xmm0,0
   cld
   mov     edx,.new_vert_ptr
 .calc_mid_vert:
   lodsd
   xchg     eax,ebx
   lodsd
   xchg     eax,ebx
   imul     eax,12
   imul     ebx,12
   add      eax,edx
   add      ebx,edx
   movups   xmm1,[eax]
   movups   xmm2,[ebx]
   addps    xmm2,xmm1
   mulps    xmm2,xmm0
   movups   [edi],xmm2
   add      edi,12
   loop     .calc_mid_vert


   mov      eax,[triangles_count_var]
   lea      eax,[eax*3]
   shl      eax,4
   add      eax,60
   malloc   eax

   mov      .new_tri,eax


   mov    esi,[triangles_ptr]
   mov    edi,eax
   mov    ecx,[triangles_count_var]
   lea    ecx,[ecx*3]
   push   ecx
   inc    ecx
   cld
 @@:
   rep    movsd

   pop    ecx
   shl    ecx,2
   add    ecx,eax
   mov    .end_new_tri,ecx
   xor    esi,esi
   
   mov      .n_tri_cnt,esi

   mov      esi,.new_tri
   xor      ecx,ecx
  .chck:
   push     ecx
   push     esi
   cmp      [tes_mod_flag],1  ; test if in do test - 'in teslate area'
   je       .in_area          ; no ?

;   lodsd
;   xchg     eax,edx
;   lodsd
;   xchg     eax,ebx
;   lodsd
;   xchg     eax,edx

   mov      eax,[esi]
   mov      ebx,[esi+4]
   mov      edx,[esi+8]
   imul     eax,12
   imul     ebx,12
   imul     edx,12
   add      eax,.new_vert_ptr
   add      ebx,.new_vert_ptr
   add      edx,.new_vert_ptr
   movlps   xmm0,[eax]
   movlps   xmm1,[ebx]
   movlps   xmm2,[edx]
   movlhps  xmm0,xmm0
   movlhps  xmm1,xmm1
   movlhps  xmm2,xmm2

   cmpltps  xmm0,[tri_area_x1]    ; check if whole tri in teslate area
   cmpltps  xmm1,[tri_area_x1]
   cmpltps  xmm2,[tri_area_x1]
   movhlps  xmm3,xmm0
   movhlps  xmm4,xmm1
   movhlps  xmm5,xmm2
   xorps    xmm3,xmm0
   xorps    xmm4,xmm1
   xorps    xmm5,xmm2
   andps    xmm3,xmm4
   andps    xmm3,xmm5
   movmskps eax,xmm3
   and      eax,11b
   cmp      eax,11b
  
   je       .in_area

  .chck_nx:
   pop      esi
   pop      ecx
   add      esi,12
   inc      ecx
   cmp      ecx,[triangles_count_var]
   jnz      .chck

   jmp      .fin


 .in_area:         ; whole tri in teslate area
   mov      eax,ecx
   cmp      .tiv,1
   jne      .nxxx  ; tiv checking ??
   movdqu   xmm1,[esi]
   mov      ecx,3
  @@: 
   movd     ebx,xmm1
   mov      edx,ebx
   shr      edx,3
   and      ebx,111b
   add      edx,[inner_vert_ptr]
   bt       dword [edx],ebx
   jnc      .nxxx
   psrldq   xmm1,4
   loop     @b
   jmp      .chck_nx

  .nxxx:
      

   
   
   cmp      [td_wp_flag],1  ; positive Z only  ?
   jne      @f
   imul     eax,12
   add      eax,[triangles_normals_rotated_ptr]
   bt       dword[eax+8],31
   jnc      .chck_nx
 @@:

   ; search for correct ed index
   movd      xmm7,esi
   movdqu    xmm0,[esi]    ;  edges
   movdqu    xmm1,[esi]
   pshufd    xmm1,xmm1,11001001b
   movd      .endin,xmm1       ; end index

   mov      ecx,3
 .in1:
   push     ecx

 .nxv:
   movd     .endin,xmm1      ; end index
   movd     eax,xmm0
;   mov      eax,[esi]       ; esi - vert index
   shl      eax,2
   add      eax,.ptr         ; eax -  addr in pivot table
                             ; ptr to all edges with this vert
   mov      edi,[eax]
 .pi:                        ; search for edge

   mov      ebx,[edi+4]      ; ebx - ed index
   shl      ebx,3
   add      ebx,[edges_ptr]
   mov      ecx,2
 .cm:
   mov      edx,[ebx]        ; ebx - vert index
;   cmp      edx,[esi]       ; 1st index - first index is for sure
;   je       .ok1
   cmp      edx,.endin   ;[esi+4]      ; 2cond
   je       .ok1
;   cmp      edx,[esi+8]      ; 3dr
;   je       .ok1
   add      ebx,4
   loop     .cm

   mov      ecx,[edi]      ;  [edi] - vert index
   add      edi,8
   cmp      ecx,[edi]
   je       .pi            ; next pos in pivot table

    int3  ;sth wrong

 .ok1:

   pop      ecx
   mov      ebx,ecx
   psrldq   xmm0,4
   psrldq   xmm1,4
   dec      ebx
   shl      ebx,2
   lea      eax,.index3
   sub      eax,ebx
;                 dword[edi+4]     -   index   of edge
   mov      edx,[points_count_var]
   add      edx,[edi+4]
   mov      [eax],edx
   loop     .in1


  ; write new triangles - append to list

   mov      edi,.end_new_tri
   movd     esi,xmm7

   mov      eax,[points_count_var]
   
   cmp      .tiv,1   ; tiv checking ?
   jne      .yes_inters
   mov      ecx,3
   movdqu   xmm4,.index1
  @@: 
   movd     edx,xmm4  
   sub      edx,eax
   mov      ebx,edx
   shr      edx,3
   and      ebx,111b
   add      edx,[edges_intersect_ptr]
   bt       dword[edx],ebx
   jc       .yes_inters
   psrldq   xmm4,4
   loop     @b
   jmp      .chck_nx
        

  .yes_inters:


   mov      edi,.end_new_tri
   movd     esi,xmm7
   
 ;  int3
   movd     xmm4,[esi]
   movd     xmm5,[esi+4]
   movd     xmm6,[esi+8]
  ;   xmm4 - xmm6   ->  indexes
   cld
   xchg     edi,esi
   
   movd     eax,xmm4 
   stosd
   mov      eax,.index1
   stosd
   mov      eax,.index3
   stosd          
   xchg     edi,esi               ;               x4
                                  ;              /  \
                                  ;           in1 -- in3
                                  ;            / \  /  \
    mov      eax,.index1          ;           x5-in2 - x6
    stosd                                                  
    mov      eax,.index2
    stosd
    mov      eax,.index3
    stosd

    mov      eax,.index1
    stosd  
    movd     eax,xmm5
    stosd
    mov      eax,.index2
    stosd

    mov      eax,.index3
    stosd  
    mov      eax,.index2
    stosd
    movd     eax,xmm6
    stosd
 
    mov      .end_new_tri,edi
    add      .n_tri_cnt,3
    jmp      .chck_nx


  .fin:

  ;reverse points_rotated to points_r
   pxor     xmm0,xmm0
   cvtdq2ps xmm3,[xxadd]
   movlhps   xmm3,xmm0 ;[the_zero]
   mov      edi,.new_vert_ptr
   mov      ecx,.new_vcnt    ; vert number
 @@:
   movlps   xmm0,[edi]
   subps    xmm0,xmm3
   movlps   [edi],xmm0
   add      edi,12
   loop     @b


   mov      esi,matrix_scaled
   lea      edi,.mx
   call     reverse_mx_3x3


   mov      esi,.new_vert_ptr    ; reverse transform tri area
   lea      ebx,.mx
   mov      edi,esi
   mov      ecx,.new_vcnt
   call     rotary



;   invoke  VirtualFree ,[points_r_ptr],0 , MEM_RELEASE
;   invoke  VirtualFree ,[triangles_ptr],0 , MEM_RELEASE
   invoke  VirtualFree ,.piv,0 , MEM_RELEASE
   invoke  VirtualFree ,.ptr,0 , MEM_RELEASE



    mov      esi,.new_tri
    mov      edi,.new_vert_ptr
;    mov      [triangles_ptr],esi
;    mov      [points_r_ptr],edi
    mov      ecx,.new_vcnt
    mov      ebx,.n_tri_cnt
;    mov      [points_count_var],ecx
    add      ebx,[triangles_count_var]
    
  .end_aa:

    mov      esp,ebp
    pop      ebp
ret

;==============================================================
remove_unused_verticesB:

; in:
;    eax - triangles (faces) ptr
;    ebx - points (vertices) ptr
;    ecx - triangles (faces) count
;    edx - points (vertices) count
; out:
;    changed points_ptr(ebx) list
;    ecx - new vertices count

    push  ebp
    mov   ebp,esp
;    sub   esp,32
  .triangles_ptr           equ [ebp-4]
  .points_ptr              equ [ebp-8]
  .triangles_count         equ [ebp-12]
  .points_count            equ dword[ebp-16]
  .nt                      equ [ebp-20]
  .accc                    equ dword[ebp-24]
  .endt                    equ [ebp-28]
  .nt1                     equ dword[ebp-32]
  .mrk                     equ word[ebp-34]

  push  eax
  push  ebx
  push  ecx
  push  edx
  sub   esp,30


  prompt  prompt_unused_vert

  mov     ebx,.triangles_count ;.triangles_count
  imul    ebx,12
  add     ebx,6400
  malloc  ebx
  mov     .nt,eax

  malloc  ebx
  mov    .nt1,eax


  mov      esi,.triangles_ptr  ;.triangles_ptr
  mov      edi,.nt
  mov      ecx,.triangles_count
  lea      ecx,[ecx*3]
  push     ecx
  cld
  rep      movsd

       pop      ecx
       mov      esi,.nt
       mov      edi,.nt1
       mov      ecx,.triangles_count ;.triangles_count
       lea      ecx,[ecx*3]
       call     sort_hybrid_dd

;    sort_hybrid_dd  calling conv
; in:  esi - 1st table
;      edi - sec table
;      ecx - tables_units count - unit 4 bytes
; out:
;      sorted first table

       invoke  VirtualFree,.nt1,0 , MEM_RELEASE



   mov     .accc,0    ; init accumulator

   mov     ecx,.points_count
   shl     ecx,2
   lea     ecx,[ecx*3]
   add     ecx,.points_ptr
   mov     .endt,ecx



 ; search for unused
   xor     edx,edx
   mov     esi,.nt

   xor     eax,eax
   mov     ebx,[esi]
   mov    .mrk,1
   cmp    [esi],dword 0         ; cause, when first isnt '0'
   jne    .rm1
  .bckrm1:           ; back
   mov     .mrk,0    ; mark
   mov     esi,.nt
   mov     ecx,.triangles_count
   lea     ecx,[ecx*3]
   dec      ecx

   cld
  .ll:
   push    ecx
   lodsd
   cmp     eax,[esi]
   je      @f
   inc     eax
   cmp     eax,[esi]
   jne     .fn     ; found unused
  .nx2:

 @@:
   pop     ecx
   loop    .ll

   jmp     .en

 .fn:   ; found "hole" in list
   movd    xmm0,[esi]
   push    esi   ; eax - index
   push    ecx


   mov     ebx,[esi]
   sub     ebx,eax       ; ebx - delta
   mov     edx,ebx
   sub     eax,.accc
 .rm1:
   mov     edx,ebx
   mov     esi,.triangles_ptr
   mov     ecx,.triangles_count
   lea     ecx,[ecx*3]
 @@:
   xor     edi,edi
   cmp     [esi],eax
   cmovae  edi,ebx
   sub     [esi],edi
   add     esi,4
   loop    @b


   mov     edi,eax
   lea     edi,[edi*3]
   shl     edi,2
   add     edi,.points_ptr


   mov     esi,edi
   shl     ebx,2
   lea     ebx,[ebx*3]
   add     esi,ebx

   cmp     esi,.endt
   ja      .ad1
 @@:
   movsd
   movsd
   movsd
   cmp     esi,.endt
   jbe     @b

  .ad1:

   add     .accc,edx        ; accumulator of "holes" value
   btr     .mrk,0           ; check higest
   jc      .bckrm1
   pop     ecx
   pop     esi
   jmp     .nx2



  .en:

      mov     eax,.accc
      mov     ebx,.points_count
      sub     ebx,eax
      inc     dword[esi]
      cmp     [esi],ebx
      cmovna   ebx,[esi]
      mov     [points_count_var],ebx

      invoke  VirtualFree,.nt,0 , MEM_RELEASE
      mov     ecx,[points_count_var]
      cls
      mov     esp,ebp
      pop     ebp

ret
