;  cones calculating according to
;  stencil buffer


; in esi - stencil buff, in position of current pixel
;    edi - destination of cones vectors
;    edx - widht
;    eax - height
; out eax = 0 not in shadow
;     else in shadow
calc_cones:

     push      ebp
     mov       ebp,esp
     sub       esp,120

     .x         equ [ebp-4]
     .y         equ [ebp-8]
     .vect_dest equ [ebp-119]
     .yres      equ dword [ebp-123]
     .width     equ dword [ebp-127]
     

     cmp        ebx,1
     jng        .en
     cmp        eax,1
     jng        .en
     pxor       xmm1,xmm1
     movd       xmm0,[xres_vard]
     punpcklwd  xmm0,xmm1
     cmp        eax,.width
     jnl        .en
     cmp        ebx,.yres
     jnl        .en
     
    ; do not call if esi addres points < esi+xres*4
    ; int3
     lea       edi,.vect_dest

   ;  mov      .x,ebx
   ;  mov      .y,eax

   ;  xor       eax,eax         ; x
   ;  xor       ebx,ebx         ; y
;     movzx       edx,word[xres_var]
;     mov       .width,edx
     xorps     xmm2,xmm2
     cvtsi2ss  xmm0,eax     ; x
     cvtsi2ss  xmm1,ebx     ; y
     movss     xmm2,[esi]   ; z
     xorps     xmm6,xmm6
     movlhps   xmm0,xmm6
     movlhps   xmm1,xmm6

     shufps    xmm1,xmm1,11110011b
     shufps    xmm0,xmm0,11111100b
     shufps    xmm2,xmm2,11001111b
     orps      xmm2,xmm1
     orps      xmm2,xmm0     ; first vertex
     movaps    xmm7,xmm2     ; xm7 - first, central vertex
     mov       edx,.width
   ;  push      edx
   ;  push      ebx
   ;  push      eax
     inc       edx
     dec       eax
     dec       ebx
     neg       edx

     mov       ecx,3
   .nx1:
     push      ecx
     mov       ecx,3
   @@:
     push      ecx
     mov       ecx,eax

     cvtsi2ss  xmm3,ecx            ; x
     mov       ecx,ebx
     cvtsi2ss  xmm4,ecx            ; y
     movss     xmm5,[esi+edx*4]    ; z
     xorps     xmm6,xmm6
     movlhps   xmm5,xmm6
     shufps    xmm5,xmm5,11001111b ; z
     movlhps   xmm4,xmm6
     shufps    xmm4,xmm4,11110011b ; y
     movlhps   xmm3,xmm6           ; x
     shufps    xmm3,xmm3,11111100b ; x
     por       xmm3,xmm4
     por       xmm3,xmm5           ; xmm3 - first point of first vec
     movups    [edi],xmm3
     add        edi,12
     inc        eax                 ; x
     inc        edx
     pop        ecx
     loop       @b
     inc        ebx                 ; y
     sub        eax,3               ; x
     pop        ecx                 ;
     add        edx,.width
     sub        edx,3
     loop       .nx1

     mov       eax,ppoint_light_coords  ;light_pos only coords
     movaps    xmm5,xmm7
     movups    xmm6,[eax]
     subps     xmm5,xmm6
     andps     xmm5,[zero_hgst]
     movaps    xmm6,xmm5
     mulps     xmm6,xmm6
     haddps    xmm6,xmm6
     haddps    xmm6,xmm6
     rsqrtps   xmm6,xmm6
     mulps     xmm5,xmm6         ; xmm5 - noralised light vect
     xor       ebx,ebx
   .ag_n:

     lea       edi,.vect_dest
     mov       ecx,8
    @@:
     movups    xmm0,[edi]        ; look at signs
     subps     xmm0,xmm7
     andps     xmm0,[zero_hgst]
     movaps    xmm1,xmm0
     mulps     xmm1,xmm1
     haddps    xmm1,xmm1
     haddps    xmm1,xmm1
     rsqrtps   xmm1,xmm1          ; xm1 - lenght
     mulps     xmm1,xmm0         
     movaps    xmm2,xmm1
     xorps     xmm1,xmm7          ; check signs equality
     movmskps  eax,xmm1           ; xm1, xm2 - cone vectors
     and        eax,111b
     or         eax,eax
     jz         .calc_dot          ; check   ; mind esp !!                             
     add        edi,12
     loop       @b

 ; if all falls, /but not only/ - invert situation
 ;    or         ebx,ebx
 ;    jz         @f
 ;    int3
 ;  @@:
 ;    pcmpeqd   xmm5,xmm5
 ;    pslld     xmm5,31
 ; lea       edi,.vect_dest
  ; mov       ecx,6
  ; @@:
  ;   movups    xmm0,[edi]
  ;   pxor      xmm0,xmm5
  ;   movups    [edi],xmm0
  ;   add       edi,16
  ;   loop      @b
  ;   pxor       xmm7,xmm5
  ;   jmp        .ag_n



   .calc_dot:
      mulps    xmm2,xmm5
      andps    xmm2,[zero_hgst]
      haddps   xmm2,xmm2
      haddps   xmm2,xmm2
      movmskps eax,xmm2
      and      eax,1b
 ;  .in_shadow:    ;   in   theory if eax = 1 -> in shadow
    .en:           ;   if eax=0 -> not , or inverted situation
      mov      esp,ebp
      pop      ebp
ret












