
   prompt_edges        db  'Calculating edges ..',0
   prompt_norm         db  'Calculating normals ..',0
   prompt_displ        db  'Making displacement ..',0
   prompt_tri          db  'Do triangulation ..',0
   prompt_unused_vert  db  'Remove unused vertices ..',0
   prompt_red_vert     db  'Remove redundant vertices ..',0
   prompt_inside_fac   db  'Remove inside faces ..',0
   prompt_rm_cracks    db  'Remove cracks ..',0
   prompt_det_chunks1  db  'Chunks detecting - first stage ..',0
   prompt_det_chunks   db  'Chunks detecting - second stage ..',0
   prompt_det_coll_ed  db  'Collided edges detecting ..',0
   prompt_smooth_in_ed db  'Smooth inside edges..',0
   prompt_ray_sh       db  'Calculating ray casted shadows ..',0
   prompt_ray_shd      db  'Ray casted shadows',0
   prompt_tes_tiv      db  'Teslating triangles with inner vertices ..',0
   prompt_mark_inn_vr  db  'Mark inside vertices ..',0
   prompt_opt          db  'Optimize chunks..',0

   uniq_ed             db  'Unique edges:',0
   faces               db  'Faces:',0
   vertices            db  'Vertices:',0
   edges_inter         db  'Collided edges:',0
   chunks_info         db  'Separate chunks number:',0
   in_vert_info        db  'Inside vertices number:',0
   curr_edit_pr_info   db  'Current edition particle:',0

   sh_model:
        .shd   TCHAR     'Spot light',0
        .fl    TCHAR     'Flat Shading',0
        .gr    TCHAR     'Gouraud Shading',0
        .sp    TCHAR     'Spherical Environment Mapping',0
        .bm    TCHAR     'Bump Mapping',0
        .tx    TCHAR     'Texture Maping',0
        .grtx  TCHAR     'Gouraud Shading and Texture Mapping',0
        .dtxx  TCHAR     'Double Texture Mapping',0
        .bmtx  TCHAR     'Bump and Texture Mapping Pararell',0
        .grl   TCHAR     'Gouraud Shaded Line',0
        .flf   TCHAR     'Flat Shading',0
        .txl   TCHAR     'Textured Line - Env. Mapping',0
        .tx12  TCHAR     'Textured Line',0
        .line  TCHAR     'Simple line without z coord. interp.',0
        .shad  TCHAR     'Nodes of object',0
        .ph    TCHAR     'Real Phongs Shading',0
        .btp   TCHAR     'Tex. with bilinear filtering + Phong',0
        .gls   TCHAR     'Glass like rendering',0
        .gls_t TCHAR     'Glass + texture mapping rendering',0
        .wtr   TCHAR     'Weighted transparency',0
        .dp    TCHAR     'Depth peeling transparency',0
        .fr    TCHAR     'Fur rendering',0
        .rc    TCHAR     'Ray casted shadows',0
    shd_model_addr:

  dw  sh_model.shd   -  sh_model
  dw  sh_model.fl    -  sh_model
  dw  sh_model.gr    -  sh_model
  dw  sh_model.sp    -  sh_model
  dw  sh_model.bm    -  sh_model
  dw  sh_model.tx    -  sh_model
  dw  sh_model.grtx  -  sh_model
  dw  sh_model.dtxx  -  sh_model
  dw  sh_model.bmtx  -  sh_model
  dw  sh_model.grl   -  sh_model
  dw  sh_model.flf   -  sh_model
  dw  sh_model.txl   -  sh_model
  dw  sh_model.tx12  -  sh_model
  dw  sh_model.line  -  sh_model
  dw  sh_model.shad  -  sh_model
  dw  sh_model.ph    -  sh_model
  dw  sh_model.btp   -  sh_model
  dw  sh_model.gls   -  sh_model
  dw  sh_model.gls_t -  sh_model
  dw  sh_model.wtr   -  sh_model
  dw  sh_model.dp    -  sh_model
  dw  sh_model.fr    -  sh_model
  dw  sh_model.rc    -  sh_model



    inner_vert_ptr       dd 0
    chunks_ptr           dd 0
    edges_intersect_ptr  dd 0
    curr_chunk           dd -1
    edges_d_count        dd 0    ; edge double/single
    ccounter             dd 0
    isAVX                db 0          ; CPU features
    isSSE42              db 0

 ;   do_submit     db 0 ; whole transform object fro rotated to base poits_r
                        ; kind of capture ...
    chunks_count         dd 0

    convert_muler:
    dd 1, 10, 100, 1000, 10000, 100000, 1000000, 10000000, 100000000
    XYZpartices:
    db 'X','Y','Z'

    peeling_particle dd 0.1
    tex_x_div2f: dd  0.5
    tex_y_div2f  dd  0.5
    tex_x_div2:  dd  TEX_X / 2
    tex_y_div2   dd  TEX_Y / 2

    i9          dd  9
    i10         dw  10
    f255d       dd  255.0
    i1000       dd  1000
    irecipr3    dd  0x55555555

    recipr6     dd  0.1666666666666667
    env_const   dd  1.05
    two_pi      dd  6.2831853
    dot_max:    dd  1.0
    dot_min:    dd  0.0
    displac_div dd  5800 ;* 3 ; displacement divisior
    rand_seed   dw  0xf2a6

    asc_file_name  db 'object '   ;  ,_,_,_,_,_,_
    .en:           db  '.asc',0
    Chfile_name    db 'chunks '   ;  ,_,_,_,_,_,_
    .en:           db  '.bin',0

    object_cnt     dd 'A'


    plane_equation:
     .A dd 0.5
     .B dd 0.5
     .C dd 1.0
     .D dd 0.0

    scale       dd 200.0
    scale_plus  dd 1.2
    scale_minus dd 0.8
    tex_scale   dd 255.0

    bbuffer_ptr    dd Bbufferv
    inf_screen_ptr dd Info_screen
    next_varw:
    next_var       dd INFOY + MYRES ; - FONT_FIX


    NextMxadd:    dw BXRES/2  ; next mesh variables
    NextMyadd     dw BYRES/2  ; dont change order !!
    NextMzadd     dw BYRES/2
                  dw 0
    NextScale     dw BYRES/2
    NextRotat:    dw BYRES - 10 ,   20
    NextScaleXY:  dw BYRES/2 + 12, BYRES/2


    NextBend1:    dw 12   , BYRES/2
    NextBend2:    dw BYRES/2  - 12 , BYRES/2
    NextBend3:    dw BYRES/2  + 24 , BYRES/2
    NextBend4:    dw BYRES    - 24 , BYRES/2

    NextMsub:      dw BXRES/2
                   dw BXRES/2
                   dw BXRES/2
                   dw 0
; dq (BYRES/2) shl 32+ (BYRES/2) shl 16 + BXRES/2
    NextScaleZero    dw BYRES/2
    NextRotatZero:   dw BYRES - 10 ,   20
    NextScaleXYZero: dw BYRES/2 + 12, BYRES/2

    NextBendZero:    dw 12   , BYRES/2
                     dw BYRES/2  - 12 , BYRES/2
                     dw BYRES/2  + 24 , BYRES/2
                     dw BYRES    - 24 , BYRES/2

    minWinX          dd BXRES + 40      ;  \
    minWinY          dd BYRES + 40      ;  /  dont change order

    NextCurvConst:   dd NEXT_CURV_NUMB/2 ,  NEXT_CURV_NUMB/2

    NextMotion         dw 0
    NextPointsCount    dd 0
    NextTrianglesCount dd 0

    tex_button_pres    db 0  ; various marks
    do_submit          db 0


    piD128:
    one_deg     dd   0.024543692

    main_rotary:
                dd 0
                dd 0
                dd 0

    all_lights_size dw lightsend-lights

    align 16

    xxadd:
                dd   ?  ;XRES/2
    yyadd       dd   ?  ;YRES/2
    zzadd       dd 0
                dd 0
    tri_area_x1:    dd 7.0  ; triangulize area
    tri_area_y1     dd 7.0
    tri_area_x2:    dd 2000.0     ; \ dont change order
    tri_area_y2     dd 2000.0     ; /


    ppoint_light_coords:
              dd 50.0
              dd 50.0
              dd 215.0
              dd 0.0

              dd 815.0
              dd 815.0
              dd 215.0
              dd 0.0

              dd 1500.0
              dd 1500.0
              dd -215.0
              dd 0.0

  lights_aligned:
    .light_vect  dd   0.0, 0.0, -1.0, 0.0
    .light_c_o:                     ;   +16
                 dd   50.0, 49.0, 44.0, 0.0
    .light_c_min:                   ;   +32
                 dd   30.0, 41.0, 30.0, 0.0
    .light_c_max:                   ;   +48
                 dd   235.0, 235.0, 5.0, 1.0

       dd   -0.5,-0.5,-1.0, 0.0
       dd   32.0, 27.0, 17.0, 0.0
       dd   1.0,1.0,1.0,0.0
       dd   253.0,253.0,235.0,0.0

       dd   0.5,0.5,-1.0,0.0
       dd   13.0,1.0,1.0,0.0
       dd   7.0,3.0,7.0,0.0
       dd   25.0, 255.0, 253.0, 0.0
  lights_aligned_end:

     aprox:          dd 1.1, 1.1, 1.1, 1.1
     slices_factor1: dd 0.85, 0.85, 0.85, 0.85
     slices_factor2: dd 0.5, 0.5, 0.5, 0.5
     slices_factor3: dd 0.35, 0.35, 0.35, 0.35
     slices_factor4: dd 0.3, 0.3, 0.3, 0.3
     slices_factor5: dd 0.23, 0.23, 0.23, 0.23
     slices_factor6: dd 0.2, 0.2, 0.2, 0.2
     slices_factor7: dd 0.1, 0.1, 0.1, 0.1


    ffd_scale:  dd 4 dup 1.0
    ffd_center: dd 4 dup 0

    blur_sub:
    sli_cnt_const:
       dd 0x01010101, 0x01010101, 0x01010101, 0x01010101

    muler1234:
    const1234:
       dd 1.0
       dd 2.0
       dd 3.0
       dd 4.0

    muler0_7:
    muler0123:
       dd 0.0
       dd 1.0
       dd 2.0
       dd 3.0
       dd 4.0
       dd 5.0
       dd 6.0
       dd 7.0
i4x4:
       dd 4, 4, 4, 4
word_max_f:
mask_65535f:
       times 4 dd 65535.0

one_hgst_dd:
           dd 0.0, 0.0, 0.0, 1.0
f2x4:
           dd 2.0, 2.0, 2.0, 2.0

zero_lowest:
           dd 0x0, 0xffffffff, 0xffffffff, 0xffffffff
sign_mask:                       ;  \
           dd 4 dup 0x80000000   ;  |
zero_hgst_dd:                    ;  |
zero_hgst:                       ;  | > dont change order
           dd -1,-1,-1,0         ;  |
f05x3:     dd 3 dup 0.5          ;  |
           dd 0.0                ;  /

abs_mask:
           dd 4 dup 0x7fffffff



f490x3:       dd 490.0, 490.0, 490.0, 0.0
f500x3:       dd 500.0, 500.0, 500.0, 0.0

z_minus_mask:
              dd 0,0,0x80000000,0

tex_m2:
              dd 4 dup 510.0

mask_255f:
correct_tex_x4f:
correct_texf:

              dd 4 dup 255.0
f3:
const3:
              dd 4 dup 3.0

f1:
the_one:
const1:
minxy:
              dd 4 dup 1.0
const4:
              dd  4.0, 4.0, 4.0, 4.0
margin3fur:
              dd -2,-2,2,2 ; 3fur.inc  ...


constrecipr6:
              dd  4 dup 0.1666666666666667
constrecip3:  dd  4 dup 0.333333

if 0
aabb:     ; axis aligned bounding box vars
  .cn1:     dd 1.0,1.0,1.0,0  ; corner1 of box
  .cn2:     dd -1.0,1.0,1.0,0
  .cn3:     dd 1.0,-1.0,1.0,0
  .cn4:     dd -1.0,-1.0,1.0,0
  .cn5:     dd 1.0,1.0,-1.0,0
  .cn6:     dd -1.0,1.0,-1.0,0
  .cn7:     dd 1.0,-1.0,-1.0,0
  .cn8:     dd -1.0,-1.0,-1.0,0

end if

 bump_consts2:   dd -TEX_Y,-1,TEX_Y-1,TEX_Y*2
 bump_trunc:     dd  4 dup  TEXTURE_SIZE
 b_shf1:         db 4, 5, 8, 9, 0, 1, 5, 6
 b_shf2:         db 6, 7, 10, 11, 9, 10, 2, 3

margin:     dd 3 dup 0.03
            dd 0
eps:
epsilon:    dd 4 dup 0.000001
eps2:       dd 4 dup 0.000002
epsilon1:   dd 4 dup 0.002
norm_dev:   dd 2 dup 0.0043
norm_dev2:  dd 2 dup 0.0043

epsilon2    dd 10.0

eps_inter:              ;  \
            dd 0.000001 ;  |  dont change order
epsminus    dd -0.0001  ;  |
epsone      dd 1.0001   ;  /
eps3        dd 0.0001

    tspoon_nodes:
include 'tspoon_nodes.txt'
    tpot_nodes:
include 'tpot_nodes.txt'
    tcup_nodes:
include 'tcup_nodes.txt'
    ffd_nodes:
include 'ffd2_nodes.txt'
    tspoon_rect:

include 'tspoon_rect.txt'
    tpot_rect:
include 'tpot_rect.txt'
    tcup_rect:
include 'tcup_rect.txt'
    ffd_rect:
include 'ffd2_rect.txt'

long_pipe_segs_c      dd 4
long_pipe_one_seg_c   dd 12  ;12 ; must be divisable by 4
lp_lenght             dd 0

  lights:

    light_vect      dd   0.0,0.0,-1.0
    light_c_o:                       ; +12
    p_light_o:
                    dw   51,71,11,0
    light_c_min:                     ; +20
    p_light_min:
                    dw   15,99,17,0
    light_c_max:
    p_light_max:
                    dw   255,255,5,0 ; +28
    shiness:
                    dw   5           ; +36
    LIGHT_SIZE = ($-lights)

        dd   -0.5,-0.5,-1.0         ;   +12
        dw   1,255,1,0              ;   +20
        dw   1,1,1,0                ;   +28
        dw   255,255,255,0
        dw   5                      ;   +36

        dd   0.5,0.5,-1.0
        dw   13,1,1,0
        dw   70,30,70,0
        dw   25,255,255,0
        dw   5
   lightsend:

filter     TCHAR   '3ds objects (*.3ds)',0,'*.3ds',0,\
                   'asc objects (*.asc)',0,'*.asc',0,\
                   'All files (*.*)',0,'*.*',0,0
_not3ds    TCHAR   'Not an 3d object file or read error.',0
_notraw    TCHAR   'Not an RAW 512X512 file or read error.',0
filter_tex TCHAR   'raw file 512X512 (*.raw)',0,'*.raw',0,\
                   'bmp file (*.bmp)',0,'*.bmp',0,\
                   'All files (*.*)',0,'*.*',0,0

; Sanctssimi Cordis Christi section |+++++++++++++++++++++++++++++
    hrt_points:
;cordis
dw 125,175,0, 175,175,0, 212,212,0, 250,175,0, 300,175,0, 325,200,0, 325,250,0
dw 300,300,0, 212,350,0, 125,300,0, 100,250,0, 100,200,0,175,250,-20,250,250,-20
;crux
dw 175,125,0, 200,125,0, 200,100,0, 225,100,0, 225,125,0, 250,125,0, 250,150,0
dw 225,150,0, 225,200,0, 200,200,0, 200,150,0, 175,150,0
;cordis next layer
dw 125,175,20, 175,175,20, 212,212,20, 250,175,20, 300,175,20, 325,200,20
dw 325,250,20, 300,300,20, 212,350,20, 125,300,20, 100,250,20, 100,200,20
dw 175,250,40, 250,250,40
;crux
dw 175,125,20, 200,125,20, 200,100,20, 225,100,20, 225,125,20, 250,125,20
dw 250,150,20, 225,150,20, 225,200,20, 200,200,20, 200,150,20, 175,150,20
;crown
;dw 50,250,-25, 50,250,25, 100,250,75, 175,250,100,  275,250,100, 350,250,75
;dw 380,250,25, 380,250,-25,350,250,-75,275,250,-100,175,250,-100, 100,250,-75
;dw 50,265,-25, 100,265,75, 275,265,100,380,265,25,  350,265,-75, 175,265,-100
;thorns
;dw 50,250,-50, 75,260,103, 275,240,150, 365,250,25, 350,260,-41, 150,240,-125

    hrt_points_count = ($-hrt_points)/6
dd -1
    hrt_triangles:
dw 1,0,12, 2,1,12, 9,8,12, 10,9,12, 11,10,12, 0,11,12, 12,13,2, 13,12,8, 3,2,13
dw 4,3,13, 5,4,13, 6,5,13, 7,6,13, 8,7,13
;crux
dw 22,21,23, 24,23,21, 25,24,14, 14,24,15, 24,18,15, 18,24,21, 21,20,18, 19,18,20
dw 16,15,18, 17,16,18
;cordis next layer
dw 26,27,38, 27,28,38, 34,35,38, 35,36,38, 36,37,38, 37,26,38, 38,39,34, 28,29,39
dw 29,30,39, 30,31,39, 31,32,39, 32,33,39, 33,34,39, 39,38,28
; crux next layer
dw 47,48,49, 49,50,47, 50,51,40, 50,40,41, 50,41,44,  41,42,44
dw 42,43,44, 44,47,50, 46,47,44, 44,45,46
;border cordis
dw 0,1,26, 1,27,26, 1,2,27, 28,27,2, 2,3,28, 29,28,3, 3,4,29, 30,29,4, 4,5,30
dw 31,30,5, 5,6,31, 32,31,6, 6,7,32, 33,32,7, 7,8,33, 34,33,8, 8,9,34, 35,34,9
dw 9,10,35, 36,35,10, 10,11,36, 37,36,11, 11,0,37, 26,37,0
;border crux
dw 14,15,40, 41,40,15, 15,16,41, 42,41,16, 16,17,42, 43,42,17, 17,18,43
dw 44,43,18, 18,19,44, 45,44,19, 19,20,45, 46,45,20, 20,21,46, 47,46,21
dw 21,22,47, 48,47,22, 23,24,49, 50,49,24, 24,25,50, 51,50,25, 25,14,51
dw 14,40,51
;crown
;dw 52,53,64, 53,54,65, 54,55,65, 55,56,66, 56,57,66, 57,58,67, 58,59,67
;dw 59,60,68, 60,61,68, 61,62,69, 62,63,69, 63,64,52
;thorns
;dw 52,64,70, 54,65,71, 56,66,72, 58,67,73, 68,60,74, 69,62,75
    hrt_triangles_count = (($-hrt_triangles)/6)
dd -1
;;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

;tetrahedron
    tetra_points_r:
dd -1.0, -1.0, 1.0
dd  1.0, -1.0, 1.0
dd  0.0,  1.0, 0.0
dd  0.0, -1.0,-1.0
    tetra_points_count = 4
dd -1 ;<- end marker

    tetra_triangles:
dw 0,1,2, 2,3,0, 2,1,3,  1,0,3
    tetra_triangles_count = 4
dd -1 ;<- end marker

    tetra_tex_points:
    dw 1,256, 511,511, 511,1
    dw 1,256, 511,511, 511,1
    dw 1,256, 511,511, 511,1
    dw 1,256, 511,511, 511,1
    dd -1

 Bfile_name    db 'object .3ds',0

font_table:
file 'font8x16.bmp'
font_tab2:
file 'font8X9.bmp'

   ; horizontal line info for first stage
   ; triangles render routines


hgrdt   dd  horizontal_tex_grd_line
hgrd    dd  gouraud_line_z
tlz     dd  textured_line_z
blz     dd  bump_line_z
blt     dd  bump_tex_line_z; 8
t2lz    dd  two_tex_line_z
sshl    dd  stencil_slices_line
shll    dd  stencil_line
cssl    dd  counter_slices_line
shal    dd  shadow_line

sli_var dd  st_sl_var_line              ;   \
shdl    dd  ray_shd_l                   ;    \
furl    dd  fur_real_phong_line_z       ;    |
gtsv    dd  glass_tex_line_sl_var       ;    |
gtsl    dd  glass_tex_line_sl           ;    |  dont change order
gltl    dd  glass_tex_line              ;    |
glas    dd  glass_line                  ;    |
bilf    dd  r_phg_bf_line_z             ;    /
rplc    dd  real_phg_line_col           ;   /


render_optss:      ; renedring options each render mode - 2 bytes
                   ; sec byte - threads count

   db 0        , 2   ; point light wit shd
   db 01000001b, 2   ; flat float  ;  0 bit - col      xmm0/xmm2
   db 00001001b, 2   ; grd   ;  1 bit - env
   db 00000110b, 2   ; env   ;  2 bit - tex/bump  - xmm6
   db 00000110b, 2   ; bump  ;  7 bit - normals -  xmm1,2,3
   db 00000110b, 2   ; tex   ;  6 bit - float z  - xmm4
   db 00001101b, 2   ; grd tex  5 bit - x max/ min -  xmm5
   db 00000110b, 2   ; two tex  3 bit - grd col withz value
   db 00000110b, 2   ; bump tex         in xmm0, xmm2
   db 00000000b, 1   ;          4 bit - stencil
   db 01000001b, 2   ; flat f   10
   db 00000000b, 1   ;
   db 00000001b, 1   ;
   db 00000001b, 1   ;
   db 10000001b, 1   ; nodes

   ; all R Phong - see peel proc in win3ds.asm file

menu_jmp_table_ptr:
   dw 0  ;WindowProc.nx1
   dw 0  ;WindowProc.nx2
   dw buttons.nx3             - buttons
   dw buttons.nx4             - buttons
   dw buttons.nx5             - buttons
   dw buttons.nx6             - buttons
   dw buttons.nx7             - buttons
   dw buttons.nx8             - buttons
   dw buttons.nx9             - buttons
   dw buttons.nx10            - buttons
   dw 0  ;buttons.nx11        - buttons
   dw 0  ;buttons.nx12        - buttons
   dw buttons.nx13            - buttons
   dw buttons.nx14            - buttons
   dw buttons.nx15            - buttons
   dw buttons.nx16            - buttons
   dw 0 ;buttons.nx17     ;  - buttons  edit
   dw 0 ;buttons.nx18         - buttons
   dw buttons.nx19            - buttons
   dw buttons.nx20            - buttons
   dw 0  ; disabled- should be - buttons.nx21            - buttons
   dw 0  ;buttons.nx22        - buttons
   dw 0  ;buttons.nx23        - buttons
   dw 0  ;buttons.nx24        - buttons
   dw 0  ;buttons.nx25        - buttons
   dw buttons.nx26            - buttons
   dw buttons.nx27            - buttons
   dw buttons.nx28            - buttons
   dw 0  ;buttons.nx29        - buttons
   dw buttons.nx30            - buttons
   dw buttons.nx31            - buttons
   dw buttons.nx32            - buttons
   dw 0  ;buttons.nx33        - buttons
   dw 0  ;buttons.nx34        - buttons
   dw buttons.nx35            - buttons
   dw buttons.nx36            - buttons
   dw buttons.nx37            - buttons
   dw buttons.nx38            - buttons
   dw buttons.nx39            - buttons
   dw 0  ;buttons.nx40        - buttons
   dw buttons.nx41            - buttons
   dw 0  ;buttons.nx42        - buttons
   dw buttons.nx43            - buttons
   dw buttons.nx44            - buttons
   dw buttons.nx45            - buttons
   dw buttons.nx46            - buttons
   dw buttons.nx47            - buttons
   dw buttons.nx48            - buttons
   dw 0  ;buttons.nx49        - buttons
   dw 0  ;buttons.nx50        - buttons
   dw buttons.nx51            - buttons
   dw buttons.nx52            - buttons
   dw buttons.nx53            - buttons
   dw buttons.nx54            - buttons
   dw buttons.nx55            - buttons
   dw buttons.nx56            - buttons
   dw buttons.nx57            - buttons
   dw 0                        ;  - buttons
   dw 0 ;buttons.nx59  ; shado- buttonsw
   dw buttons.nx57            - buttons
   dw buttons.nx61            - buttons
   dw buttons.nx62            - buttons
   dw 0                       ;   - buttons


menu_button_number  dw 0

menu_data:

               dw 0                ; mark if button chosen
               dw 2                ; x1
               dw 2                ; y1
               dw 85               ; x2
               dw 20               ; y2
               db 'rotary    ',0   ; label
               db 4                ; max flag  + 1 , if = 255, no flag
  rotary_flag  db 0                ; flag
               dd axl_f            ; offset to flags description
               dw 1                ; button number
               dw VK_F12           ; key 1
               dw 0                ; key 2 if '0' - none

 .op   =  ($ - menu_data)

               dw 0
               dw 2                ; x1
               dw 22               ; y1
               dw 85               ; x2
               dw 40
               db 'mot. blur ',0
               db 2
   blur_flag   db 1
               dd on_of_f
               dw 2
               dw VK_F1
               dw 0

               dw 0
               dw 2                ; x1
               dw 42               ; y1
               dw 85               ; x2
               dw 60
               db 'zoom in   ',0
               db 2
               db 0
               dd -1              ; if 0xffffffff - no flag desc
               dw 3
               dw VK_F3
               dw VK_ADD

               dw 0
               dw 2                ; x1
               dw 62               ; y1
               dw 85               ; x2
               dw 80
               db 'zoom out  ',0
               db 2
               db 0
               dd -1
               dw 4
               dw VK_F4
               dw VK_SUBTRACT

               dw 0
               dw 2                ; x1
               dw 82               ; y1
               dw 85               ; x2
               dw 100
               db 'tex. mapp.',0
               db 4
    map_flag   db 0
               dd tex_map_f
               dw 5
               dw VK_F5
               dw 0

               dw 0
               dw 2
               dw 102
               dw 85
               dw 120
               db 'ran. light',0
               db 2
       rd_flag db 0
               dd -1
               dw 6
               dw VK_TAB
               dw 0

               dw 0
               dw 2                ; x1
               dw 122               ; y1
               dw 85               ; x2
               dw 140
               db 'dr. model ',0
     max_draw  db 22 ; max val changed if non sse4
     draw_flag db 15  ; - only nodes (vertices) dbg
               dd -1
               dw 7
               dw VK_SPACE
               dw 0

               dw 0
               dw 2                ; x1
               dw 142               ; y1
               dw 85               ; x2
               dw 160
               db 'bumps     ',0
               db 2
     bump_flag db 0
               dd bumps_f
               dw 8
               dw VK_F6
               dw 0

               dw 0
               dw 2                ; x1
               dw 162              ; y1
               dw 85               ; x2
               dw 180
               db 'texture   ',0
               db 3
     tex_flag  db 0
               dd tex_f
               dw 9
               dw VK_F7
               dw 0

               dw 0
               dw 2                ; x1
               dw 182              ; y1
               dw 85               ; x2
               dw 200
               db 'save obj. ',0
               db 2
     sav_flag  db 0
               dd -1
               dw 10
               dw VK_F8
               dw 0

               dw 0
               dw 2                ; x1
               dw 202              ; y1
               dw 85               ; x2
               dw 220
               db 'run / stop',0
               db 2
  ccounter_inc db 1
               dd run_st_f
               dw 11
               dw VK_F11
               dw 0

               dw 0
               dw 2                ; x1
               dw 222              ; y1
               dw 85               ; x2
               dw 240
               db 'culling   ',0
               db 2
  culling_flag db 1
               dd on_of_f
               dw 12
               dw VK_F9
               dw 0


               dw 0
               dw 130             ; x1
               dw 2               ; y1
               dw 212             ; x2
               dw 20
               db 'do displ. ',0  ; displacement
               db 2
               db 0
               dd -1
               dw 13
               dw 0x44             ; D
               dw 0

               dw 0
               dw 130              ; x1
               dw 22               ; y1
               dw 212              ; x2
               dw 40
               db 'do triang.',0
               db 2
               db 0
               dd -1
               dw 14
               dw 0x54             ; T
               dw 0

               dw 0
               dw 130               ; x1
               dw 42                ; y1
               dw 212               ; x2
               dw 60                ; y2
               db 'cur object',0
               db 3  ; 6
      hrt_flag db 0
               dd cur_obj_f
               dw 15
               dw VK_F2
               dw 0


               dw 0                ; mark if button chosen
               dw 130              ; x1
               dw 62               ; y1
               dw 212              ; x2
               dw 80               ; y2
               db 'rand. shd.',0   ; label
               db 255              ; max flag  + 1 , if = 255, no flag
    xchg_flag  db 0                ; flag
               dd -1               ; offset to flags description
               dw 16               ; button number
               dw 0x55             ; key 1
               dw 0                ; key 2 if '0' - none



               dw 0                ; mark if button chosen
               dw 130              ; x1
               dw 82               ; y1
               dw 212              ; x2
               dw 100              ; y2
               db 'edit mesh.',0   ; label
               db 4                ; max flag  + 1 , if = 255, no flag
    edit_flag  db 0                ; flag
               dd edit_f           ; offset to flags description
               dw 17               ; button number
               dw 0x56             ; key 1    'V'
               dw 0                ; key 2 if '0' - none


               dw 0
               dw 130                ; x1
               dw 102                ; y1
               dw 212                ; x2
               dw 120
               db 'set t.area',0
               db 2
 set_tri_area  db 1
               dd on_of_f          ; if 0xffffffff - no flag desc
               dw 18
               dw 0x57             ; W
               dw 0

               dw 0           ; set displacement transparent color
               dw 130         ; x1
               dw 122         ; y1
               dw 212         ; x2
               dw 140
               db 'set t. col',0
               db 2
 disp_col_flag  db 0
               dd displac_f   ; if 0xffffffff - no flag desc
               dw 19
               dw 0x43
               dw 0

               dw 0                ; mark if button chosen
               dw 130              ; x1
               dw 142              ; y1
               dw 212              ; x2
               dw 160              ; y2
               db 'dsp factor',0   ; label
               db 4                ; max flag  + 1 , if = 255, no flag
  disp_fac_flag  db 0              ; flag
               dd d_factor_f       ; offset to flags description
               dw 20               ; button number
               dw 0x46             ; key 1    'F'
               dw 0                ; key 2 if '0' - none


               dw 0                ; mark if button chosen
               dw 130              ; x1
               dw 162              ; y1
               dw 212              ; x2
               dw 180              ; y2
               db 'bezier sr.',0   ; label
               db 1 ;- disabled ; should be 5                ; max flag  + 1 , if = 255, no flag
  bezier_flag  db 0                ; flag
               dd bezier_f         ; offset to flags description
               dw 21               ; button number
               dw 0x42             ; 'B'
               dw 0

               dw 0                ; mark if button chosen
               dw 130              ; x1
               dw 182              ; y1
               dw 212              ; x2
               dw 200              ; y2
               db 'set ap tol',0   ; label
               db 12               ; max flag  + 1 , if = 255, no flag
tolerancy_flag db 1                ; flag
               dd approx_toler_f   ; offset to flags description
               dw 22               ; button number
               dw 0x41             ;   'A'
               dw 0

               dw 0                ; mark if button chosen
               dw 130              ; x1
               dw 202              ; y1
               dw 212              ; x2
               dw 220              ; y2
               db 'b.der.edit',0   ; label
               db 2                ; max flag  + 1 , if = 255, no flag
derive_flag    db 0                ; flag
               dd of_on_f          ; offset to flags description
               dw 23               ; button number
               dw 0x45             ;   'e'
               dw 0





               dw 0                ; mark if button chosen
               dw 130              ; x1
               dw 222              ; y1
               dw 212              ; x2
               dw 240              ; y2
               db 't&d wh|pos',0   ; label
               db 2                ; max flag  + 1 , if = 255, no flag
td_wp_flag     db 0                ; triangulation & displacement flag
                                   ; if set on 'posi' - only positive
                                   ; z cooficient vertices are affected,
                                   ; if set on 'whol' all vertices are
                                   ; in triangulation and displacement
                                   ; process affected
               dd t_and_d_f        ; offset to flags description
               dw 24               ; button number
               dw 0                ;
               dw 0

               dw 0                ; mark if button chosen
               dw 258              ; x1
               dw 2                ; y1
               dw 340              ; x2
               dw 20               ; y2
               db 'speed     ',0   ; label
               db 2                ; max flag  + 1 , if = 255, no flag
speed_flag     db 0                ; flag
               dd speed_f          ; offset to flags description
               dw 25               ; button number
               dw 0x53             ;   'S'
               dw 0


               dw 0                ; mark if button chosen
               dw 258              ; x1
               dw 22               ; y1
               dw 340              ; x2
               dw 40               ; y2
               db 'Rm unu ver',0   ; label
               db 2                ; max flag  + 1 , if = 255, no flag
               db 0                ; flag
               dd -1               ; offset to flags description
               dw 26               ; button number
               dw 19  ;0x48             ;   ''
               dw 0

               dw 0                ; mark if button chosen
               dw 258              ; x1
               dw 42               ; y1
               dw 340              ; x2
               dw 60               ; y2
               db 'Long pipe ',0   ; label
               db 3                ; max flag  + 1 , if = 255, no flag
  lpipe_flag   db 0                ; flag
               dd lpipe_f          ; offset to flags description
               dw 27               ; button number
               dw 0x50             ;   'P'
               dw 0

               dw 0                ; mark if button chosen
               dw 258              ; x1
               dw 62               ; y1
               dw 340              ; x2
               dw 80               ; y2
               db 'Lp segs cn',0   ; label
               db 4                ; max flag  + 1 , if = 255, no flag
  lpsegs_flag  db 2                ; flag
               dd lp_segs_f        ; offset to flags description
               dw 28               ; button number
               dw 0x49             ;   ''
               dw 0



               dw 0                ; mark if button chosen
               dw 258              ; x1
               dw 82               ; y1
               dw 340              ; x2
               dw 100              ; y2
               db 'Lp Bez/Bsp',0   ; label
               db 2                ; max flag  + 1 , if = 255, no flag
  lpcurve_tp   db 0                ; flag
               dd lp_cv_type_f     ; offset to flags description
               dw 29               ; button number
               dw 0x49             ;   ''
               dw 0

               dw 0                ; mark if button chosen
               dw 258              ; x1
               dw 102              ; y1
               dw 340              ; x2
               dw 120              ; y2
               db 'Lp quality',0   ; label
               db 4                ; max flag  + 1 , if = 255, no flag
  lp_quality   db 0                ; flag
               dd lp_qual          ; offset to flags description
               dw 30               ; button number
               dw 0x49             ;   ''
               dw 0

               dw 0                ; mark if button chosen
               dw 258              ; x1
               dw 122              ; y1
               dw 340              ; x2
               dw 140              ; y2
               db 'NextM edit',0   ; label   ; next mesh edit
               db 4                ; max flag  + 1 , if = 255, no flag
 NextMed_flag  db 0                ; flag
               dd nx_ed_f          ; offset to flags description
               dw 31               ; button number
               dw 0x16             ;   ''
               dw 72

               dw 0                ; mark if button chosen
               dw 258              ; x1
               dw 142              ; y1
               dw 340              ; x2
               dw 160              ; y2
               db 'Rm red ver',0   ; label   ; next mesh edit
               db 255              ; max flag  + 1 , if = 255, no flag
               db 0                ; flag
               dd -1               ; offset to flags description
               dw 32               ; button number
               dw 0x51             ;   ''
               dw 0

               dw 0                ; mark if button chosen
               dw 258              ; x1
               dw 162              ; y1
               dw 340              ; x2
               dw 180              ; y2
               db 'Draw norm.',0   ; label
               db 3                ; max flag  + 1 , if = 255, no flag
  normals_flag db 0                ; flag
               dd normals_f        ; offset to flags description
               dw 33               ; button number
               dw 0x4f             ; 'o'
               dw 0

               dw 0                ; mark if button chosen
               dw 258              ; x1
               dw 182              ; y1
               dw 340              ; x2
               dw 200              ; y2
               db 'Z rdu care',0   ; label
               db 2                ; max flag  + 1 , if = 255, no flag
   Z_care_flag db 1                ; flag
               dd of_on_f          ; offset to flags description
               dw 34               ; button number
               dw 0x52             ;  'r'
               dw 0




               dw 0                ; mark if button chosen
               dw 258              ; x1
               dw 202              ; y1
               dw 340              ; x2
               dw 220              ; y2
               db 'Rm ins fac',0   ; label
               db 255              ; max flag  + 1 , if = 255, no flag
               db 0                ; flag
               dd -1               ; offset to flags description
               dw 35               ; button number
               dw 0x54
               dw 0


                    dw 0                ; mark if button chosen
                    dw 258              ; x1
                    dw 222              ; y1
                    dw 340              ; x2
                    dw 240              ; y2
                    db 'Ma Coll Ed',0   ; label
                    db 2                ; max flag  + 1 , if = 255, no flag
  mark_coll_ed_flag db 0                ; flag
                    dd of_on_f          ; offset to flags description
                    dw 36               ; button number
                    dw 0x1e
                    dw 0


                    dw 0                ; mark if button chosen
                    dw 2                ; x1
                    dw 242              ; y1
                    dw 85               ; x2
                    dw 260              ; y2
                    db 'Srch Chunk',0   ; label
                    db 2                ; max flag  + 1 , if = 255, no flag
  srch_chunk_flag   db 0                ; flag
                    dd of_on_f          ; offset to flags description
                    dw 37               ; button number
                    dw 0x1e
                    dw 0

                    dw 0                ; mark if button chosen
                    dw 2                ; x1
                    dw 262              ; y1
                    dw 85               ; x2
                    dw 280              ; y2
                    db 'Sm ins edg',0   ; label
                    db 2                ; max flag  + 1 , if = 255, no flag
                    db 0                ; flag
                    dd -1               ; offset to flags description
                    dw 38               ; button number
                    dw 0x1e
                    dw 0

                    dw 0                ; mark if button chosen
                    dw 2                ; x1
                    dw 282              ; y1
                    dw 85               ; x2
                    dw 300              ; y2
                    db 'Clip faces',0   ; label
                    db 2                ; max flag  + 1 , if = 255, no flag
                    db 0                ; flag
                    dd -1               ; offset to flags description
                    dw 39               ; button number
                    dw 0x1e
                    dw 0

                    dw 0                ; mark if button chosen
                    dw 2                ; x1
                    dw 302              ; y1
                    dw 85               ; x2
                    dw 320              ; y2
                    db 'Invert chn',0   ; label
                    db 2                ; max flag  + 1 , if = 255, no flag
    invert_n_flag   db 0                ; flag
                    dd of_on_f          ; offset to flags description
                    dw 40               ; button number
                    dw 0x1e
                    dw 0

                    dw 0                ; mark if button chosen
                    dw 2                ; x1
                    dw 322              ; y1
                    dw 85               ; x2
                    dw 340              ; y2
                    db 'Crop front',0   ; label
                    db 255              ; max flag  + 1 , if = 255, no flag
                    db 0                ; flag
                    dd -1               ; offset to flags description
                    dw 41               ; button number
                    dw 0x1e
                    dw 0

                    dw 0                ; mark if button chosen
                    dw 2                ; x1
                    dw 342              ; y1
                    dw 85               ; x2
                    dw 360              ; y2
                    db 'Del. chunk',0   ; label
                    db 2               ; max flag  + 1 , if = 255, no flag
    del_chn_flag    db 0                ; flag
                    dd del_ch_f         ; offset to flags description
                    dw 42               ; button number
                    dw 0x1e
                    dw 0




                    dw 0                ; mark if button chosen
                    dw 2                ; x1
                    dw 362              ; y1
                    dw 85               ; x2
                    dw 380              ; y2
                    db 'Ray shdows',0   ; label
                    db 2                ; max flag  + 1 , if = 255, no flag
    ray_shd_flag    db 0                ; flag
                    dd of_on_f         ; offset to flags description
                    dw 43               ; button number
                    dw 0x1e
                    dw 0




                    dw 0                ; mark if button chosen
                    dw 2                ; x1
                    dw 382              ; y1
                    dw 85               ; x2
                    dw 400              ; y2
                    db 'Tes TIV IE',0   ; label
                    db 255               ; max flag  + 1 , if = 255, no flag
                    db 0                ; flag
                    dd -1               ; offset to flags description
                    dw 44               ; button number
                    dw 0x1e
                    dw 0

                    dw 0                ; mark if button chosen
                    dw 2                ; x1
                    dw 402              ; y1
                    dw 85               ; x2
                    dw 420              ; y2
                    db 'Mark in vr',0   ; label
                    db 2                ; max flag  + 1 , if = 255, no flag
    inner_vert_flag db 0                ; flag
                    dd of_on_f          ; offset to flags description
                    dw 45               ; button number
                    dw 0x1e
                    dw 0


                    dw 0                ; mark if button chosen
                    dw 2                ; x1
                    dw 422              ; y1
                    dw 85               ; x2
                    dw 440              ; y2
                    db 'Rm TIV NIE',0   ; label
                    db 255              ; max flag  + 1 , if = 255, no flag
                    db 0                ; flag
                    dd -1               ; offset to flags description
                    dw 46               ; button number
                    dw 0x1e
                    dw 0




                    dw 0                ; mark if button chosen
                    dw 130              ; x1
                    dw 242               ; y1
                    dw 212              ; x2
                    dw 260              ; y2
                    db 'Rm dead tr',0   ; label
                    db 255              ; max flag  + 1 , if = 255, no flag
                    db 0                ; flag
                    dd -1               ; offset to flags description
                    dw 47               ; button number
                    dw 0x1e
                    dw 0


                    dw 0                ; mark if button chosen
                    dw 130              ; x1
                    dw 262               ; y1
                    dw 212              ; x2
                    dw 280              ; y2
                    db 'Rm cracks ',0   ; label
                    db 255              ; max flag  + 1 , if = 255, no flag
                    db 0                ; flag
                    dd -1               ; offset to flags description
                    dw 48               ; button number
                    dw 0x1e
                    dw 0


                    dw 0                ; mark if button chosen
                    dw 130              ; x1
                    dw 282              ; y1
                    dw 212              ; x2
                    dw 300              ; y2
                    db 'Tes Wh/Tar',0   ; label
                    db 2                ; max flag  + 1 , if = 255, no flag
      tes_mod_flag  db 1                ; flag
                    dd tes_f            ; offset to flags description
                    dw 49               ; button number
                    dw 0x1e
                    dw 0


                    dw 0                ; mark if button chosen
                    dw 130              ; x1
                    dw 302               ; y1
                    dw 212              ; x2
                    dw 320              ; y2
                    db 'Show chunk',0   ; label
                    db 2                ; max flag  + 1 , if = 255, no flag
     show_ch_flag   db 0                ; flag
                    dd of_on_f         ; offset to flags description
                    dw 50               ; button number
                    dw 0x1e
                    dw 0

                    dw 0                ; mark if button chosen
                    dw 130              ; x1
                    dw 322              ; y1
                    dw 212              ; x2
                    dw 340              ; y2
                    db 'tex +     ',0   ; label
                    db 255                ; max flag  + 1 , if = 255, no flag
                    db 0                ; flag
                    dd -1 ;of_on_f          ; offset to flags description
                    dw 51               ; button number
                    dw 0x1e
                    dw 0



                    dw 0                ; mark if button chosen
                    dw 130              ; x1
                    dw 342               ; y1
                    dw 212              ; x2
                    dw 360              ; y2
                    db 'tex -     ',0   ; label
                    db 255                ; max flag  + 1 , if = 255, no flag
                    db 0                ; flag
                    dd -1 ;of_on_f          ; offset to flags description
                    dw 52               ; button number
                    dw 0x1e
                    dw 0



                    dw 0                ; mark if button chosen
                    dw 130              ; x1
                    dw 362              ; y1
                    dw 212              ; x2
                    dw 380              ; y2
                    db 'fix norm V',0   ; label
                    db 255              ; max flag  + 1 , if = 255, no flag
                    db 0                ; flag
                    dd -1               ; offset to flags description
                    dw 53               ; button number
                    dw 0x1e
                    dw 0


                    dw 0                ; mark if button chosen
                    dw 130              ; x1
                    dw 382              ; y1
                    dw 212              ; x2
                    dw 400              ; y2
                    db 'make serie',0   ; label
                    db 255              ; max flag  + 1 , if = 255, no flag
                    db 0                ; flag
                    dd -1               ; offset to flags description
                    dw 54               ; button number
                    dw 0x1e
                    dw 0

                    dw 0                ; mark if button chosen
                    dw 130              ; x1
                    dw 402              ; y1
                    dw 212              ; x2
                    dw 420              ; y2
                    db 'sort chunk',0   ; label
                    db 255              ; max flag  + 1 , if = 255, no flag
                    db 0                ; flag
                    dd -1               ; offset to flags description
                    dw 55               ; button number
                    dw 0 ;0x4e
                    dw 0


                    dw 0                ; mark if button chosen
                    dw 130              ; x1
                    dw 422              ; y1
                    dw 212              ; x2
                    dw 440              ; y2
                    db 'Submit obj',0   ; label
                    db 2                ; max flag  + 1 , if = 255, no flag
       submit_flag  db 0                ; flag
                    dd blank_f          ; offset to flags description
                    dw 56               ; button number
                    dw 0 ;0x4e
                    dw 0


                    dw 0                ; mark if button chosen
                    dw 340 - 82           ; x1
                    dw 242              ; y1
                    dw 340              ; x2
                    dw 260              ; y2
                    db 'Zero Next ',0   ; label
                    db 255              ; max flag  + 1 , if = 255, no flag
       zero_Nx_flag db 0                ; flag
                    dd -1               ; offset to flags description
                    dw 57               ; button number
                    dw 0 ;0x4e
                    dw 0

                    dw 0                ; mark if button chosen
                    dw 340 - 82         ; x1
                    dw 262              ; y1
                    dw 340              ; x2
                    dw 280              ; y2
                    db 'Mirror ch.',0   ; label
                    db 2                ; max flag  + 1 , if = 255, no flag
       mirr_flag    db 0                ; flag
                    dd of_on_f          ; offset to flags description
                    dw 58               ; button number
                    dw 0 ;0x4e
                    dw 0

                    dw 0                ; mark if button chosen
                    dw 340 - 82         ; x1
                    dw 282              ; y1
                    dw 340              ; x2
                    dw 300              ; y2
                    db 'Shadow    ',0   ; label
                    db 2                ; max flag  + 1 , if = 255, no flag
     shadow_flag    db 0                ; flag
                    dd of_on_f          ; offset to flags description
                    dw 59               ; button number
                    dw 0 ;0x4e
                    dw 0

                    dw 0                ; mark if button chosen
                    dw 340 - 82         ; x1
                    dw 302              ; y1
                    dw 340              ; x2
                    dw 320              ; y2
                    db 'FFD       ',0   ; label
     maxffd         db 3                ; max flag  + 1 , if = 255, no flag
     ffd_flag       db 0                ; flag
                    dd ffd_f            ; offset to flags description
                    dw 60               ; button number
                    dw 0 ;0x4e
                    dw 0


                    dw 0                ; mark if button chosen
                    dw 340 - 82         ; x1
                    dw 322              ; y1
                    dw 340              ; x2
                    dw 340              ; y2
                    db 'R Ph bumps',0   ; label
     max_rpbump     db 4                ; max flag  + 1 , if = 255, no flag
     rph_bump_flag  db 0                ; flag
                    dd rphb_f           ; offset to flags description
                    dw 61               ; button number
                    dw 0 ;0x4e
                    dw 0

                    dw 0                ; mark if button chosen
                    dw 340 - 82         ; x1
                    dw 342              ; y1
                    dw 340              ; x2
                    dw 360              ; y2
                    db 'DoDefNxNor',0   ; label
                    db 255              ; max flag  + 1 , if = 255, no flag
                    db 0                ; flag
                    dd -1               ; offset to flags description
                    dw 62               ; button number
                    dw 0 ;0x4e
                    dw 0

                    dw 0                ; mark if button chosen
                    dw 340 - 82         ; x1
                    dw 362              ; y1
                    dw 340              ; x2
                    dw 380              ; y2
                    db 'Dr.ValencE',0   ; label
                    db 2                ; max flag  + 1 , if = 255, no flag
    valencEd_flag   db 0                ; flag
                    dd of_on_f          ; offset to flags description
                    dw 63               ; button number
                    dw 0 ;0x4e
                    dw 0


               dw -1  ; <- end flag
ffd_f:
     db 'off ',0
     db 'patc',0
     db 'vol.',0

blank_f:
     db '    ',0
     db '    ',0
nx_ed_f:
     db 'off ',0
     db 'Nx.o',0
     db 'chun',0
     db 'whol',0
tes_f:
     db 'tesA',0
     db 'Whol',0
del_ch_f:
     db 'off ',0
     db 'del.',0
normals_f:
     db 'off ',0
     db 'tri.',0
     db 'vert',0
lp_cv_type_f:
     db 'Bezr',0
     db 'Bspl',0

lp_segs_f:
     db ' 2  ',0
     db ' 4  ',0
     db ' 8  ',0
     db ' 16 ',0
lpipe_f:
     db 'off ',0
     db 'edit',0
     db 'calc',0
speed_f:
     db 'idle',0
     db 'full',0

t_and_d_f:
     db 'whol',0
     db 'posi',0
bezier_f:
     db 'off ',0
     db 'pot ',0
     db 'cup ',0
     db 'spoo',0
     db 'box ',0
rphb_f:
     db 'off  ',0
lp_qual:
approx_toler_f:
d_factor_f:
     db '1   ',0
     db '2   ',0
     db '3   ',0
     db '4   ',0
     db '5   ',0
     db '6   ',0
     db '7   ',0
     db '8   ',0
     db '9   ',0
     db '10  ',0
     db '11  ',0
     db '12  ',0
displac_f:
     db 'whit',0
     db 'blck',0
edit_f:
     db 'off ',0
     db 'vert',0
     db 'face',0
     db 'edge',0
cur_obj_f:
     db 'file',0
     db 'hrt ',0
     db 'tetr',0
     db 'r.s.',0
     db 'pipe',0
     db 'r.sp',0
tex_map_f:
     db 'p.xy',0
     db 'p.xz',0
     db 'p.yz',0
     db 'sph.',0
axl_f:
     db 'y   ',0
     db 'z   ',0
     db 'x   ',0
     db 'cust',0
on_of_f:
     db 'on  ',0
     db 'off ',0
of_on_f:
     db 'off ',0
     db 'on  ',0
bumps_f:
     db 'rand',0
     db 'tex ',0
tex_f:
     db 'str.',0
     db 'xor ',0
     db 'none',0
run_st_f:
    db  'stop',0
    db  'run ',0

    custom_obj_angle      dd 0
    custom_rot_start_x    dw 0, 0
    edit_particle_no      dd -1
    edit_tri_area         db 0
    displ_transparent_col dd 0x00ffffff


    min_work_x:     dw 6         ; \
    min_work_y      dw 6         ; |> dont change order
    max_work_x:     dw 2000      ; |
    max_work_y      dw 2000      ; /

    ed_bpatch_derives_x_start: dw 0   ; bezier patch edition
    ed_bpatch_derives_y_start  dw 0
    ed_bpatch_derives_x_end:   dw 0
    ed_bpatch_derives_y_end    dw 0
    ed_bpatch_derive_no        dw 2  ; number
    ed_bpatch_derive_on        dw 0  ; 0 - off, 1 - on
    ed_bpatch_mv_process       dd 0  ; mouse move process



    tex_mov_begin_x:
                     dw 0 ;  \ dont change order
    tex_mov_begin_y  dw 0 ;  /
    CoresCount       dd 0,0
  align 4
    ProcessAffinityMask dd 0
    SystemAffinityMask  dd 0
  align 4

    msg      MSG
    rect     RECT
    ofn      OPENFILENAME sizeof.OPENFILENAME,0,0,filter,0,0,0,fname,260 ;MAXSIZE
    ofntex   OPENFILENAME sizeof.OPENFILENAME,0,0,filter_tex,0,0,0,fnametex,260 ;MAXSIZE
    ofnnext  OPENFILENAME sizeof.OPENFILENAME,0,0,filter,0,0,0,fnamenext,260 ;MAXSIZE
    wc       WNDCLASS 0,WindowProc,0,0,NULL,NULL,NULL,1,NULL,_class
;    ps       PAINTSTRUCT
    long_pipe_derv_init:
       dd 1.0,0.0,0.0
    long_pipe_derv:
       rd 65536   ; mem for control points of
                  ; long pipe
    long_pipe_derv_rotated rd 65536
    NextBendDerv           rb 65536

    initXsize       dd ?     ; sizes at start
    initYsize       dd ?

    ffd_nodes_intial     rd 100000
    ffd_nodes_rot        rd 200000
    ffd_nodes_intial_rot rd 100000
    ffd_verts_intial     rd 64 * 64 * 6 * 12 * 2 + 10000
    ffd_verts_rot        rd 64 * 64 * 6 * 12 * 2 + 10000  ;100000 ; 30 * 30 * 6 * 12 + 5000
    ffd_nodes_unpck      rb 12 * 1000 + 500 ;(max ~ 1000 unpacked  nodes)
  align  16
    ffd_nodes_unpck_alig rb 12 * 1000 + 500
  align 16
    ffd_nodes_unpck_inti rb 12 * 1000 + 500 ;(
  align 16
    nodes_aligned      rb 12 * 16 * 4 + 500
  align 16
    nodes_aligned_inti rb 12 * 16 * 4 + 500
    ffd_faces          rd 64 * 64 * 6 * 12 * 2 + 5000
    ffd_tri_cnt        dd ?
    ffd_vert_cnt       dd ?
    bez_patch_count            dw ?
    bez_nodes_count            dw ?


   align 16
    thread_params:   rd 160

    ; params to threaded procs mem area

    align 16

    ThreadMaskArray rd 64  ; dup 0

    ThreadID0    dd ?
    ThreadID1    dd ?
    ThreadID2    dd ?
    ThreadID3    dd ?
    ThreadID4    dd ?
    ThreadID5    dd ?
    ThreadID6    dd ?
    ThreadID7    dd ?
    ThreadID8    dd ?
    ThreadID9    dd ?
    ThreadID10   dd ?
    ThreadID11   dd ?
    ThreadID12   dd ?
    ThreadID13   dd ?
    ThreadID14   rd 51


    hthread0        rd 1
    hthread1        rd 1
    hthread2        rd 1
    hthread3        rd 1
    hthread4        rd 1
    hthread5        rd 1
    hthread6        rd 1
    hthread7        rd 1
    hthread8        rd 1
    hthread9        rd 1
    hthread10       rd 1
    hthread11       rd 1
    hthread12       rd 1
    hthread13       rd 1
    hthread14       rd 51



    whole_xres      dw ?
    whole_yres      dw ?
    xres_vard:
    xres_var        dw ?
    yres_var        dw ?
    File_ptr       dd ?
    File_tex_ptr   dd ?

    EndFile        dd ?

    edges_coll_count     dd ?
    inner_vert_number    dd ?


    edit_start_x    dw ?   ; \
    edit_start_y    dw ?   ; |> dont change order
    edit_end_x      dw ?   ; |
    edit_end_y      dw ?   ; /

    ; pointers...

    furs_ptr:                     dd ?  ;,?,?,?

    triangles_normals_ptr         dd ?      ; \
    triangles_normals_rotated_ptr dd ?      ;  \
    points_normals_ptr            dd ?      ;  |
    points_count_var              dd ?      ;  |
    triangles_count_var           dd ?      ;  |
                                            ;  |
    points_r_ptr                  dd ?      ;  | > dont change order
    triangles_ptr                 dd ?      ;  | >
    points_rotated_ptr            dd ?      ;  |
    points_normals_rotated_ptr    dd ?      ;  |
    edges_ptr                     dd ?      ;  |
    edges_count                   dd ?      ;  |
    edge_s_d_ptr                  dd ?      ;  |
    screen_ptr                    dd ?      ;  |         ; edge single - bit is zeroed
    Zbuffer_ptr                   dd ?      ;  |
    slices_counter_ptr            dd ?      ;  |
    slices_ptrs_buff_ptr          dd ?      ;  /
    tex_points_f_ptr              dd ?      ; /

    shd_buffer_ptr                dd ?
    edit_buf_ptr                  dd ?
    edit_tri_area_ptr             dd ?   ; 2 bits for each pixel
    chunks_desc_ptr               dd ?
    chunk_descEx_ptr              dd ? ; every chunk 64 bytes
                                       ; first 12 - max vertex
                                       ; + 12  - min vertex
                                       ; + 24  - middle vert
                                       ; next - yet free

    tex_points_ptr                dd ?  ; bump_map  and texture coords
                                        ; each point word x, word y
    shadow_vertices_ptr           dd ?
    derv_rect_ptr                 dd ?
    derv_nodes_ptr                dd ?
    long_pipe_vert_ptr            dd ?
    slices_ptr                    dd ?
    voxels_depth_ptr              dd ?

   align 16

    matrix           rb 36
    matrix_scaled    rb 36

    file_ext_flag    db ?   ; 0 - 3ds, 1 - asc
    fname            rb     260 ;MAXSIZE
    fnametex         rb     260
    fnamenext        rb     260
    BytesRead        dd ?
    hfile            dd ?
    hfiletex         dd ?
    FileSize         dd ?
    byteswritten     dd ?
    hheap            dd ?
    pmem             dd ?
    pmemtex          dd ?
    hwnd             dd ?
    hdc              dd ?


    bmi              BITMAPINFOHEADER
    Mbmi             BITMAPINFOHEADER  ; menu scroll pipe
  ;  MPbmi            BITMAPINFOHEADER ; menu
    Pbmi             BITMAPINFOHEADER  ; prompt
  ;  Ibmi             BITMAPINFOHEADER ; info
  ;  Bbmi             BITMAPINFOHEADER ; Next Edit bar
    Wbmi             BITMAPINFOHEADER  ; Whole window
    ascii_obj_cnt: rb 255
    noise_buff     rb 65536 * 2 + 1024
  ;  fog_seeds     rb (128 * 128 * 64)   + 128
  align 16
    bump_map      rb TEX_X * TEX_Y
    envmap        rd TEX_X * TEX_Y
    color_map:    rd TEX_X * TEX_Y
    texmap        rd TEX_X * TEX_Y
  align 16
    prompt_screen rd PROMPTX * PROMPTY
    menu_screen   rd MXRES * MYRES
    Info_screen:
                  rd INFOX * INFOY
    Bbufferv:
    rd BXRES*BYRES

    sin_cos_tab256:  rd 512
    fog_seeds:       rb 30 *  80000
